 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory");

dojo.provide("");
dojo.require("com.ibm.team.workitem.web.cache.internal.WorkItemProxy");

(function() { //module container
var lastId = -1;

com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory = {	
	/*
	 * Create a new work item proxy
	 * This method is repeated in WorkItemProxy as _getNewWorkItemProxy (avoiding circular dependencies)
	 */
	getWorkItemProxy: function(parms /* id, createIfNeeded, incrementUseCount, doNotCache */) {
		var id = parms.id || lastId--;
		var workItemProxy = com.ibm.team.workitem.web.cache.internal.Cache.getItem(id);
		if(workItemProxy || !parms.createIfNeeded) return workItemProxy;
		
		/* if ID is -1 then it is a new item and should be converted to a unique id */
		if(id == -1) {
			id = -1 * Date.parse(new  Date().toString())
		}
		
		var object= {
			attributes: {
				id: {
					id: id
				}
			}
		}
		workItemProxy =  new com.ibm.team.workitem.web.cache.internal.WorkItemProxy({ object: object, isFetched: false}); // empty object initially
		
		if(!parms.doNotCache) {
			com.ibm.team.workitem.web.cache.internal.Cache.addItem(id, workItemProxy);			
		} else {
			workItemProxy.isNotCached = true;
		}
		
		if(parms.incrementUseCount) {
			workItemProxy.incrementUseCount();
		}
		return workItemProxy;
	}
};

})();