/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.client.internal.AdminPageRegistry"); //$NON-NLS-1$

dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$

(function() { // module container

var RegistryFactory = jazz.core.RegistryFactory;

com.ibm.team.reports.web.client.internal.AdminPageRegistry = {
	
	// ---- API ------------------------------------------------------------------------------------------------------------	
	
	getContributedPages: function() {
		if (this._contributedPages == null) {
			this._loadContributedPages();
		}
		return this._contributedPages;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_contributedPages: null,

	_loadContributedPages: function() {
		var extensionPoint = RegistryFactory.getRegistry().getExtensionPoint("com.ibm.team.reports.web.adminPage"); //$NON-NLS-1$

		var contributedPages = [];
		dojo.forEach(extensionPoint.getExtensions(), function(extension) {
			dojo.forEach(extension.getConfigurationElements(), function(configElement) {
				contributedPages.push({
					id: configElement.getAttribute("id"), //$NON-NLS-1$
					name: configElement.getAttribute("name"), //$NON-NLS-1$
					widgetId: configElement.getAttribute("widgetId"), //$NON-NLS-1$
					visibility: configElement.getAttribute("visibility") //$NON-NLS-1$
				});
			});
		});
		
		this._contributedPages = contributedPages;
	},

	__sentinel: null // terminates this class definition
	
};

})();