/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
(function() { // avoid variables in the global (window) scope
	
var WorkItemAttributes= dojo.provide("com.ibm.team.workitem.web.client.internal.WorkItemAttributes");

// Internal IDs
WorkItemAttributes.SEVERITY= "internalSeverity";
WorkItemAttributes.PRIORITY= "internalPriority";
WorkItemAttributes.FOUND_IN= "foundIn";
WorkItemAttributes.ID= "id";
WorkItemAttributes.TYPE= "workItemType";
WorkItemAttributes.PROJECT_AREA= "projectArea";
WorkItemAttributes.SUMMARY= "summary";
WorkItemAttributes.STATE= "internalState";
WorkItemAttributes.CREATOR= "creator";
WorkItemAttributes.OWNER= "owner";
WorkItemAttributes.DESCRIPTION= "description";
WorkItemAttributes.CREATION_DATE= "creationDate";
WorkItemAttributes.RESOLUTION= "internalResolution";
WorkItemAttributes.DUE_DATE= "dueDate";
WorkItemAttributes.ESTIMATE= "duration";
WorkItemAttributes.CORRECTED_ESTIMATE= "correctedEstimate";
WorkItemAttributes.TIME_SPENT= "timeSpent";
WorkItemAttributes.CATEGORY= "category";
WorkItemAttributes.TARGET= "target";
WorkItemAttributes.RESOLVER= "resolver";
WorkItemAttributes.RESOLUTION_DATE= "resolutionDate";
WorkItemAttributes.TAGS= "internalTags";
WorkItemAttributes.MODIFIED= "modified";
WorkItemAttributes.MODIFIED_BY= "modifiedBy";

// External IDs
WorkItemAttributes.EXT_SEVERITY= "com.ibm.team.workitem.attribute.severity";
WorkItemAttributes.EXT_PRIORITY= "com.ibm.team.workitem.attribute.priority";
WorkItemAttributes.EXT_FOUND_IN= "com.ibm.team.workitem.attribute.version";
WorkItemAttributes.EXT_ID= "com.ibm.team.workitem.attribute.id";
WorkItemAttributes.EXT_TYPE= "com.ibm.team.workitem.attribute.workitemtype";
WorkItemAttributes.EXT_PROJECT_AREA= "com.ibm.team.workitem.attribute.projectarea";
WorkItemAttributes.EXT_SUMMARY= "com.ibm.team.workitem.attribute.summary";
WorkItemAttributes.EXT_STATE= "com.ibm.team.workitem.attribute.state";
WorkItemAttributes.EXT_CREATOR= "com.ibm.team.workitem.attribute.creator";
WorkItemAttributes.EXT_OWNER= "com.ibm.team.workitem.attribute.owner";
WorkItemAttributes.EXT_DESCRIPTION= "com.ibm.team.workitem.attribute.description";
WorkItemAttributes.EXT_CREATION_DATE= "com.ibm.team.workitem.attribute.creationdate";
WorkItemAttributes.EXT_RESOLUTION= "com.ibm.team.workitem.attribute.resolution";
WorkItemAttributes.EXT_DUE_DATE= "com.ibm.team.workitem.attribute.duedate";
WorkItemAttributes.EXT_ESTIMATE= "com.ibm.team.workitem.attribute.duration";
WorkItemAttributes.EXT_CORRECTED_ESTIMATE= "com.ibm.team.workitem.attribute.correctedestimate";
WorkItemAttributes.EXT_TIME_SPENT= "com.ibm.team.workitem.attribute.timespent";
WorkItemAttributes.EXT_CATEGORY= "com.ibm.team.workitem.attribute.category";
WorkItemAttributes.EXT_TARGET= "com.ibm.team.workitem.attribute.target";
WorkItemAttributes.EXT_RESOLVER= "com.ibm.team.workitem.attribute.resolver";
WorkItemAttributes.EXT_RESOLUTION_DATE= "com.ibm.team.workitem.attribute.resolutiondate";
WorkItemAttributes.EXT_TAGS= "com.ibm.team.workitem.attribute.tags";
WorkItemAttributes.EXT_MODIFIED= "com.ibm.team.workitem.attribute.modified";
WorkItemAttributes.EXT_MODIFIED_BY= "com.ibm.team.workitem.attribute.modifiedby";

var i2e= new Object();
var e2i= new Object();

i2e[WorkItemAttributes.SEVERITY]= WorkItemAttributes.EXT_SEVERITY;
i2e[WorkItemAttributes.PRIORITY]= WorkItemAttributes.EXT_PRIORITY;
i2e[WorkItemAttributes.FOUND_IN]= WorkItemAttributes.EXT_FOUND_IN;
i2e[WorkItemAttributes.ID]= WorkItemAttributes.EXT_ID;
i2e[WorkItemAttributes.TYPE]= WorkItemAttributes.EXT_TYPE;
i2e[WorkItemAttributes.PROJECT_AREA]= WorkItemAttributes.EXT_PROJECT_AREA;
i2e[WorkItemAttributes.SUMMARY]= WorkItemAttributes.EXT_SUMMARY;
i2e[WorkItemAttributes.STATE]= WorkItemAttributes.EXT_STATE;
i2e[WorkItemAttributes.CREATOR]= WorkItemAttributes.EXT_CREATOR;
i2e[WorkItemAttributes.OWNER]= WorkItemAttributes.EXT_OWNER;
i2e[WorkItemAttributes.DESCRIPTION]= WorkItemAttributes.EXT_DESCRIPTION;
i2e[WorkItemAttributes.CREATION_DATE]= WorkItemAttributes.EXT_CREATION_DATE;
i2e[WorkItemAttributes.RESOLUTION]= WorkItemAttributes.EXT_RESOLUTION;
i2e[WorkItemAttributes.DUE_DATE]= WorkItemAttributes.EXT_DUE_DATE;
i2e[WorkItemAttributes.ESTIMATE]= WorkItemAttributes.EXT_ESTIMATE;
i2e[WorkItemAttributes.CORRECTED_ESTIMATE]= WorkItemAttributes.EXT_CORRECTED_ESTIMATE;
i2e[WorkItemAttributes.TIME_SPENT]= WorkItemAttributes.EXT_TIME_SPENT;
i2e[WorkItemAttributes.CATEGORY]= WorkItemAttributes.EXT_CATEGORY;
i2e[WorkItemAttributes.TARGET]= WorkItemAttributes.EXT_TARGET;
i2e[WorkItemAttributes.RESOLVER]= WorkItemAttributes.EXT_RESOLVER;
i2e[WorkItemAttributes.RESOLUTION_DATE]= WorkItemAttributes.EXT_RESOLUTION_DATE;
i2e[WorkItemAttributes.TAGS]= WorkItemAttributes.EXT_TAGS;
i2e[WorkItemAttributes.MODIFIED]= WorkItemAttributes.EXT_MODIFIED;
i2e[WorkItemAttributes.MODIFIED_BY]= WorkItemAttributes.EXT_MODIFIED_BY;

for (var internalId in i2e) {
	e2i[i2e[internalId]]= internalId;
}

WorkItemAttributes.getInternalId= function(externalId) {
	var internalId= e2i[externalId];
	return internalId ? internalId : externalId;
};

WorkItemAttributes.getExternalId= function(internalId) {
	var externalId= i2e[internalId];
	return externalId ? externalId : internalId;
};

	
})();