/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.ajaxModules.AjaxModuleWrapper");

dojo.require("dijit._Widget");
dojo.require("com.ibm.rational.cm.web._base");

(function(){

var cq = com.ibm.rational.cm.web;

dojo.declare(
	"com.ibm.rational.cm.web.ui.ajaxModules.AjaxModuleWrapper",
	dijit._Widget,
{
	widgetClass: null,
	props: {}, // set property values that you want to pass programatically
	
	postCreate: function(){
		this.inherited(arguments);
		
		// get properties from query string
		var qryObj;
		var widgetClass = this.widgetClass;
		var qstr = dojo.global.location.search.substr(1);
		if(qstr.length > 0){
			qryObj = dojo.queryToObject(qstr);
			if(!widgetClass || widgetClass.length === 0){
				widgetClass = qryObj.widgetClass;
			}
		}
		if(!widgetClass){
			this.domNode.innerHTML = "Error: Parameter 'widgetClass' was not specified";
			return;
		}

		// create property object
		var props = this.props;
		for(var key in qryObj){
			if(key != "widgetClass" && key != "debug"){
				props[key] = qryObj[key];
			}
		}
		
		// instantiate widget
		var self = this;
		cq.loadModule(widgetClass, function(){
			var impl = dojo.getObject(widgetClass);
			var widget = self.widget = new impl(props);
			self.domNode.appendChild(widget.domNode);
		});
	}
});

})();