/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.Constants");

dojo.require("dojo.i18n");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");

(function() {
	
	var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
	var	_messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMessages");
	
	com.ibm.team.dashboard.web.ui.internal.Constants = { 
		serverError: "com.ibm.team.dashboard.events.serverError",
		hideServerError: "com.ibm.team.dashboard.events.hideServerError",
	
		// -------- Common Constants ------------------------
		// com.ibm.team.dashboard.web.ui.internal.Constants
		DASHBOARD_CONTENT_CLASS: "com-ibm-team-dashboard-content",
		
		URL_PARAM_ACTION: "action",
		URL_PARAM_ACTION_VIEW_PAGE: "jazz.viewPage",
		URL_PARAM_ACTION_VIEW_PAGE_ID: "id",
		
		// TEMPORARY CONSTANT, SHOULD BE IN REPO
		// See work item 72055
		CONTEXT_PUBLIC: "_8lNyYNwSEd2pIJ5QVwgQGg",
		
		// -------- Edit Mode Constants --------------------
		READ_ONLY: 0,
		EDIT_DEFERRED_SAVE: 1,
		EDIT_AUTO_SAVE: 2,
		
		// -------- Observable Property Constants -------------------------
		PROPERTY_DASHBOARD: "dashboard",
		PROPERTY_CONTRIBUTOR_INFO: "contributorInfo",
			
		// -------- Viewlet Definition Applies To Constants ---------------
		SCOPE_APPLIES_TO_ALL: "ALL",
		SCOPE_APPLIES_TO_TEAMS: "TEAMS",
		SCOPE_APPLIES_TO_PROJECTS: "PROJECTS",
		SCOPE_APPLIES_TO_PROCESS: "PROJECTS_AND_TEAMS",
		SCOPE_APPLIES_TO_CONTRIBUTORS: "CONTRIBUTORS",
		
		// -------- ViewletContainer Constants --------------
		// com.ibm.team.dashboard.web.ui.internal.Constants.ViewletContainer
		ViewletContainer: {
			MIDDLE_SECTION_COLLAPSED_CLASS: "middle-section-collapsed",
			HEADER_COLLAPSED_CLASS: "header-collapsed",
			OPEN_MENU_CLASS: "open-menu",
			
			EXPAND_CLASS: "expand",
			COLLAPSE_CLASS: "collapse",
			EXPAND_TITLE: _messages.expand,
			COLLAPSE_TITLE: _messages.collapse,
			
			CONTENT_ZOOMED_CLASS: "content-zoomed",
			CONTENT_WRAPPER_ZOOMED_CLASS: "content-wrapper-zoomed",
			VIEWLET_ZOOMED_CLASS: "viewlet-zoomed",
			COLUMN_ZOOMED_CLASS: "column-zoomed",
		
			ZOOM_WIDTH: 600,
			LAST_COL_MENU_OFFSET: 16,
			ZOOM_ICON_SCROLLBAR_HORIZ_OFFSET: 1,
			ZOOM_ICON_DEFAULT_HORIZ_OFFSET: 1
		},
		
		// -------- LeftNav Constants -----------------------
		// com.ibm.team.dashboard.web.ui.internal.Constants.LeftNav
		LeftNav: {
			ROOT_CLASS: "com-ibm-team-dashboard-left-nav",
			SEARCH_CLASS: "com-ibm-team-dashboard-left-nav-search",
			SELECTED_DASHBOARD_CLASS: "selected",
			COMMAND_CLASS: "command",
			DELETE_BUTTON_DIV_CLASS: "delete",
			LOADING_CLASS: "loading",
			
			LINK_ID_SUFFIX: "-link",
			LI_ID_SUFFIX: "-li",
			
			REMOTE_ERROR: "LeftNav.js remote error: ",
			LEFT_NAV_INFO_ERROR: "Error getting left nav info: "
		},
		
		// -------- SettingsArea Constants ------------------
		// com.ibm.team.dashboard.web.ui.internal.Constants.SettingsArea
		SettingsArea: {
			
			FIELD_HIDDEN: "HIDDEN",
			FIELD_PASSWORD: "PASSWORD",
			FIELD_COLOR: "COLOR",
			FIELD_CUSTOM: "CUSTOM",
			FIELD_LIST: "LIST",
			FIELD_COMPUTED: "COMPUTED",
			FIELD_BOOLEAN: "BOOLEAN",
			FIELD_STRING: "STRING",
			FIELD_INTEGER: "INTEGER"
		
		}
	};
})();
