/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportParamDate");

dojo.require("dojo.i18n");
dojo.require("dojo.date.locale");

dojo.require("dijit.form.DateTextBox");

dojo.require("com.ibm.team.reports.web.ui.internal.ReportParam");
dojo.require("com.ibm.team.reports.web.ui.internal.utils.StringUtils");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
	
	var StringUtils = com.ibm.team.reports.web.ui.internal.utils.StringUtils;
	
    dojo.declare("com.ibm.team.reports.web.ui.internal.ReportParamDate", [com.ibm.team.reports.web.ui.internal.ReportParam], {
        templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportParamDate.html"),
		
		widgetsInTemplate: true,
		
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		postCreate: function() {
			var self = this;
			dojo.connect(this.dateTextBox, "onChange", this, function(arg) {
				self.onDirty();
			});
		},
        
		getSelectedValues: function() {
			var date = this.dateTextBox.getValue();
			if (!date || date.length == 0) {
				return null;
			}
			return [date.getDate() + "/" + (date.getMonth() + 1) + "/" + date.getFullYear()];
		},
		
		setDefaultValues: function() {
			if (this.parameterDTO.defaultValue) {
				this.dateTextBox.setValue(StringUtils.stringToDate(this.parameterDTO.defaultValue));
			}
		},
		
		setValues: function(values) {
			if (values && values.length > 0) {
				this.dateTextBox.setValue(StringUtils.stringToDate(values));
			}
			if (!this.isInputEnabled) {
				this.disableInput();	
			}
		},
		
		remoteError: function(error) {
			alert(error.message);
		}
		
	});
	
})();
