/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.SaveAsDialog");

dojo.require("dojo.i18n");
dojo.require("dojo.date.locale");

dojo.require("dijit.Dialog");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
    dojo.declare("com.ibm.team.reports.web.ui.internal.SaveAsDialog", [dijit._Widget, dijit._Templated], {
       templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/SaveAsDialog.html"),
		
		widgetsInTemplate: true,
		
		constructor: function(props) {
			dojo.mixin(this, props);
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		_onSubmit: function() {
			if (this.onSubmit && this.textField.value.length > 0) {
				this.onSubmit(this.textField.value);
			}
			this.close();
		},
		
		_onClose: function() {
			dojo.forEach(this._dialog._modalconnects, dojo.disconnect);
			this._dialog.destroyRecursive();
		},
		
		close: function (){
			this._onClose();
		},
		
		open: function() {
			this._dialog.show();
			this.textField.focus();
		}
		
	});
	
})();
