/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates");//$NON-NLS-1$
	dojo.require("dojo.i18n");//$NON-NLS-1$
	dojo.require("dojox.data.dom");//$NON-NLS-1$
	dojo.require("dijit.form.Textarea"); //$NON-NLS-1$
	dojo.require("dijit.form.TextBox");//$NON-NLS-1$
	dojo.require("dijit.form.Button");//$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI");//$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.projectarea");//$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.ui.internal.admin.ItemList");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$//$NON-NLS-2$
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var ImportTemplateDialog = com.ibm.team.process.web.ui.internal.admin.process_templates.ImportTemplateDialog;
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var UIHelper = com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var TEMPLATES_PER_PAGE = 20;
	var currentTotalTemplates;
	var currentUpperBound;
	//constants for ids of elements and dijits
	var NAME = "name";//$NON-NLS-1$
	var PROCESS_ID = "processId";//$NON-NLS-1$
	var SUMMARY = "summary";//$NON-NLS-1$
	var TYPES = [NAME, PROCESS_ID, SUMMARY];
	var NAME_EDIT = "nameEdit";//$NON-NLS-1$
	var PROCESS_ID_EDIT = "processIdEdit";//$NON-NLS-1$
	var SUMMARY_EDIT = "summaryEdit";//$NON-NLS-1$
	var CANCEL_BUTTON = "cancel"; //$NON-NLS-1$
	var SAVE_BUTTON = "save"; //$NON-NLS-1$
	var CHANGES_PENDING = "changesPending"; //$NON-NLS-1$
	var SAVE_IN_PROGRESS = -1;
	
	var SERVICE_URI = dojo.baseUrl + "../../service/com.ibm.team.process.internal.service.web.IProcessDefinitionFileService/";//$NON-NLS-1$
	function setText(e, text){
		e.appendChild(document.createTextNode(text));
	}
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.process_templates.ManageTemplates", com.ibm.team.repository.web.ui.internal.admin.ItemList, { //$NON-NLS-1$
		constructor: function(){
			this.actionToolbars = [];
			this._saveButtons = {};
			this.templateBeingEdited = null;
			this.navigationClickHandler = null;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.process_templates", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function(){
			setText(this.heading, this.messages.ManageTemplates_1);
			setText(this.description, this.messages.ManageTemplates_2);
			dojo.addClass(this.tableContents, ProcessConstants.CSSClass.TOOLBAR_TABLE);
			dojo.addClass(this.tableContents, "templateTable", true);   //$NON-NLS-1$
			this.tableHeading.parentNode.removeChild(this.tableHeading);
			this.setHeaderRow([this.messages.ManageTemplates_3, this.messages.ManageTemplates_8, this.messages.ManageTemplates_4, this.messages.ManageTemplates_26]);
			this.headerRow.cells[0].style.width = "25%"; //$NON-NLS-1$
			this.headerRow.cells[1].style.width = "25%"; //$NON-NLS-1$
			dojo.addClass(this.headerRow.cells[3], ProcessConstants.CSSClass.ACTION_COLUMN);
			this.headerRow.cells[3].style.width = "15%"; //$NON-NLS-1$
			this.importButtonCH = this.addNewButton("", this.messages.ManageTemplates_5); //$NON-NLS-1$
			this.importButton = this.importButtonCH[0];
			
			dojo.disconnect(this.importButtonCH);
			this.connect(this.importButton, "onclick", function(e){ //$NON-NLS-1$            
				var dialog = new ImportTemplateDialog();
				this.connect(dialog, "onSuccess", "handleImportTemplateSuccess");//$NON-NLS-1$ //$NON-NLS-2$ 
			});
			
			this.deployButtonCH = this.addNewButton("", this.messages.ManageTemplates_15);//$NON-NLS-1$
			this.deployButton = this.deployButtonCH[0];
			
			dojo.disconnect(this.deployButtonCH);
			this.connect(this.deployButton, "onclick", "performDeployTemplates");//$NON-NLS-1$ //$NON-NLS-2$
			this.deployButton.disabled = true;
			this.importButton.disabled = true;
			
		},
		
		show: function(args){
			this.refresh(args);
		},
		refresh: function(args){			
			this.clearState();
			var tr = document.createElement("tr"); //$NON-NLS-1$
			var td = document.createElement("td"); //$NON-NLS-1$
			td.colSpan = 2;
			td.appendChild(document.createTextNode(this.messages.ManageTemplates_6));
			tr.appendChild(td);
			this.tbody.appendChild(tr);
			if (!args || !args.pageNum) {
				this.queryPageNumber = 0;
			} else {
				var intPageNum = parseInt(args.pageNum);
				this.queryPageNumber = intPageNum;
			}
			var queryArgs = {
				pageNum: this.queryPageNumber,
				pageSize: TEMPLATES_PER_PAGE
			};
			var errorHandler = "handleShowTemplatesError";//$NON-NLS-1$  
			if (args && args.error) {
				errorHandler = args.error;	
			}
			var srh = new ServiceResponseHandler(this, "showTemplates", errorHandler); //$NON-NLS-1$  
			ProcessClient.getProcessDefinitions(queryArgs, srh);
		},
		reload: function(args){
			if (!this._confirmLoseEdits()) {
				return;
			}
			this._destroyEditDijits(this._templateBeingEdited);
			this._templateBeingEdited = null;
			this.refresh(args);
		},
		clearState: function(){
			dojox.data.dom.removeChildren(this.tbody);
			dojox.data.dom.removeChildren(this.messageDiv);
			dojox.data.dom.removeChildren(this.messageBox);
			this.messageBox.className = "";//$NON-NLS-1$
			this._destroyActionToolbars();
		},
		
		showTemplates: function(data){
			dojox.data.dom.removeChildren(this.tbody);
			
			if (this.pagerDiv == null) {
				this.createPagerDiv();
			}
			
			//assume we are going to enable the deploy button
			var isDeployButtonDisabled = false;
			var self = this;
			
			this.updatePagerDivLinksEnablement(data);
			if (data && data.count > 0) {
				this.updatePagerDivLinks();
				
				var sortedTemplates = data.elements.sort(function(a, b){
					var translatedNameA = self.getTranslatedProcessDefinitionName(a);
					var translatedNameB = self.getTranslatedProcessDefinitionName(b);
					return translatedNameA.toLowerCase().localeCompare(translatedNameB.toLowerCase());
				});
				for (var i = 0; i < sortedTemplates.length; i++) {
					var row = this.createRowForTemplate(sortedTemplates[i]);
				}
			} else {
				var message;
				if (this.isDeployed === true) {
					message = this.messages.ManageTemplates_35;
					//don't enable the deploy button if there are no templates
					isDeployButtonDisabled = true;
				} else {
					message = this.messages.ManageTemplates_9;
				}
				
				this.messageDiv.appendChild(document.createTextNode(message));
			}
			this.deployButton.disabled = isDeployButtonDisabled;
			this.importButton.disabled = false;
		},
		updatePagerDivLinksEnablement: function(data){
			var message;
			var lowerBound, upperBound;
			if (data) {
				this.currentTotalTemplates = data.count;
				if (data.count > TEMPLATES_PER_PAGE) {
					lowerBound = (this.queryPageNumber * TEMPLATES_PER_PAGE) + 1;
					this.currentUpperBound = (this.queryPageNumber + 1) * TEMPLATES_PER_PAGE;
					if (this.queryPageNumber === 0) {
						dojo.toggleClass(this.pagerDiv.prevSpan, "disabled", true);//$NON-NLS-1$
					} else {
						dojo.toggleClass(this.pagerDiv.prevSpan, "disabled", false);//$NON-NLS-1$
					}
					if (this.currentUpperBound >= data.count) {
						this.currentUpperBound = data.count;
						dojo.toggleClass(this.pagerDiv.nextSpan, "disabled", true);//$NON-NLS-1$
					} else {
						dojo.toggleClass(this.pagerDiv.nextSpan, "disabled", false);//$NON-NLS-1$
					}
				} else {
					this._disablePagerLinks();
					if (data.count == 0) {
						lowerBound = 0;
						this.currentUpperBound = 0;
					} else {
						lowerBound = 1;
						this.currentUpperBound = data.count;
					}
				}
			}
			this.updatePagerRange(lowerBound, this.currentUpperBound, this.currentTotalTemplates);
		},
		updatePagerRange: function(lowerBound, upperBound, total){
			this.pagerDiv.rangeSpan.innerHTML = dojo.string.substitute(this.messages.ManageTemplates_39, [lowerBound, upperBound, total]);
		},
		createRowForTemplate: function(datum){
			var nameNode = document.createElement("div");//$NON-NLS-1$
			var itemId = datum.itemId;
			dojo.attr(nameNode, "id", datum.itemId + NAME);//$NON-NLS-1$
			dojo.attr(nameNode, NAME, datum.name);
			var nameText = this.getTranslatedProcessDefinitionName(datum);
			var nameTextNode = document.createTextNode(nameText);
			nameNode.appendChild(nameTextNode);
			
			var idNode = document.createElement("div");//$NON-NLS-1$
			dojo.attr(idNode, "id", datum.itemId + PROCESS_ID);//$NON-NLS-1$
			var idTextNode = document.createTextNode(datum.processId);
			idNode.appendChild(idTextNode);
			
			var descNode = document.createElement("div"); //$NON-NLS-1$
			dojo.attr(descNode, "id", datum.itemId + SUMMARY);//$NON-NLS-1$
			dojo.attr(descNode, SUMMARY, datum.summary);
			//IE does not show top of cell if it has no text, so set the text to
			//a space if the summary is empty.
			var translatedSummary = this.getTranslatedProcessDefinitionSummary(datum);
			var summaryText = translatedSummary ? translatedSummary : " "; //$NON-NLS-1$
			var summaryTextNode = document.createTextNode(summaryText);
			
			descNode.appendChild(summaryTextNode);
			
			//create the row and add the process and state id's so we can save
			//edits
			var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
			this.actionToolbars.push(trToolbar);
			var exportAction = {};
			exportAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/export.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			exportAction.label = dojo.string.substitute(this.messages.ManageTemplates_7, [nameText]);
			exportAction.callbackData = {
				actionHref: SERVICE_URI + datum.itemId
			};
			var callback = function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (!this._isEditInProgress()) {
					window.location = e.currentTarget.callbackData.actionHref;
				}
			};
			trToolbar.addButton(this, callback, exportAction);
			
			var deleteAction = {};
			deleteAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/delete_hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			deleteAction.label = dojo.string.substitute(this.messages.ManageTemplates_17, [nameText]);
			deleteAction.callbackData = {
				projectItemId: datum.itemId
			};
			callback = function(e){
				dojo.stopEvent(e);
				if (!this._isEditInProgress()) {
					this.handleDeleteTemplate(e.currentTarget.callbackData.projectItemId);
				}
			};
			trToolbar.addButton(this, callback, deleteAction);
			
			var editAction = {};
			editAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/images/edit.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			editAction.label = dojo.string.substitute(this.messages.ManageTemplates_36, [nameText]);
			editAction.callbackData = {
				projectItemId: datum.itemId
			};
			callback = function(e){
				dojo.stopEvent(e);
				if (!this._isEditInProgress()) {
					this._showTemplateEditor(e.currentTarget.callbackData.projectItemId);
				}
			};
			trToolbar.addButton(this, callback, editAction);
			
			var row = this.addRow(null, [nameNode, idNode, descNode, trToolbar.domNode]);
			dojo.attr(row, "processItemId", datum.itemId);//$NON-NLS-1$
			dojo.attr(row, "stateId", datum.stateId);//$NON-NLS-1$
			return row;
		},
		_isEditInProgress: function(){
			return this.templateBeingEdited && this.templateBeingEdited !== SAVE_IN_PROGRESS;
		},
		
		/*
		 * Show a new row that has editable controls.
		 */
		_showTemplateEditor: function(processItemId){
			this._disableToolbars(true);
			this._disablePagerLinks();
			this.importButton.disabled = true;
			
			//set the global flag to prevent editing others
			this.templateBeingEdited = processItemId;
			
			//hide the old row
			var row = this._getRowForItemId(processItemId);
			var stateId = dojo.attr(row, "stateId"); //$NON-NLS-1$
			dojo.addClass(row, "hidden");//$NON-NLS-1$
			//register a click handler in case user leaves page
			this.bodyClickHandler = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
			this.onBeforeUnloadHandler = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this._navigateAwayEvent), /*priority*/ 10000);
			
			//create the new row 
			var newRow = row.parentNode.insertRow(row.rowIndex - 1);
			dojo.style(newRow, "backgroundColor", "#F2F8FC");//$NON-NLS-1$ //$NON-NLS-2$
			//make name column
			var nameColumn = newRow.insertCell(0);
			
			var nameInputDiv = document.createElement("div");//$NON-NLS-1$
			nameColumn.appendChild(nameInputDiv);
			
			var nameDivNode = dojo.byId(processItemId + NAME);
			dojo.attr(nameDivNode, CHANGES_PENDING, false);
			var name = dojo.attr(nameDivNode, NAME);
			var self = this;
			
			var nameTextBox = new dijit.form.TextBox({
				id: processItemId + NAME_EDIT,
				value: name,
				intermediateChanges: true,
				onChange: function(newText){
					if (newText != name) {
						self._enableSaveButton(processItemId);
						dojo.attr(nameDivNode, CHANGES_PENDING, true);
					} else {
						self._disableSaveButton(processItemId);
						dojo.attr(nameDivNode, CHANGES_PENDING, false);
					}
				}
			}, nameInputDiv);
			nameTextBox.startup();
			
			//make ID column
			var idColumn = newRow.insertCell(1);
			var idInputDiv = document.createElement("div");//$NON-NLS-1$
			idColumn.appendChild(idInputDiv);
			
			var id = dojo.byId(processItemId + PROCESS_ID).innerHTML;
			var idTextBox = new dijit.form.TextBox({
				id: processItemId + PROCESS_ID_EDIT,
				value: id,
				intermediateChanges: true,
				onChange: function(newText){
					if (newText != id) {
						self._enableSaveButton(processItemId);
					} else {
						self._disableSaveButton(processItemId);
					}
				}
			}, idInputDiv);
			idTextBox.startup();
			
			//make summary column
			var summaryDivNode = dojo.byId(processItemId + SUMMARY);
			dojo.attr(summaryDivNode, CHANGES_PENDING, false);
			var summary = dojo.attr(summaryDivNode, SUMMARY);
			
			var summaryColumn = newRow.insertCell(2);
			var summaryInputDiv = document.createElement("div");//$NON-NLS-1$
			summaryColumn.appendChild(summaryInputDiv);
			
			var summaryTextarea = new dijit.form.Textarea({
				id: processItemId + SUMMARY_EDIT,
				value: summary,
				intermediateChanges: true,
				onChange: function(newText){
					if (summary) {
						summary = dojo.string.trim(summary);
					}
					if (newText != summary) {
						self._enableSaveButton(processItemId);
						dojo.attr(summaryDivNode, CHANGES_PENDING, true);
					} else {
						self._disableSaveButton(processItemId);
						dojo.attr(summaryDivNode, CHANGES_PENDING, false);
					}
				}
			}, summaryInputDiv);
			var summaryEditStyleNode = summaryTextarea.styleNode;
			summaryTextarea.startup();
			
			//make buttons in actions column
			var iconColumn = newRow.insertCell(3);
			
			var saveParameters = {
				itemId: processItemId,
				stateId: stateId,
				disabled: true
			};
			var saveButton = document.createElement("button"); //$NON-NLS-1$
			dojo.mixin(saveButton, saveParameters);
			saveButton.appendChild(document.createTextNode(this.messages.ManageTemplates_29));
			this.connect(saveButton, "onclick", this._handleSaveEdit); //$NON-NLS-1$
			iconColumn.appendChild(saveButton);
			this._saveButtons[processItemId] = saveButton;
			
			var cancelParameters = {
				processItemId: processItemId
			};
			var cancelButton = document.createElement("button");//$NON-NLS-1$
			cancelButton.appendChild(document.createTextNode(this.messages.ManageTemplates_28));
			dojo.mixin(cancelButton, cancelParameters);
			iconColumn.appendChild(cancelButton);
			this.connect(cancelButton, "onclick", this._handleCancelEdit); //$NON-NLS-1$
			UIHelper.resizeI18NButtons(cancelButton, [cancelButton, saveButton], 0, 1.25);
			
		},
		/**
		 * Dispose of the edit controls and show the regular row for
		 * the template being edited.
		 * @param {Object} event
		 */
		_handleCancelEdit: function(event){
			dojo.stopEvent(event);
			this.templateBeingEdited = null;
			var dij = event.target;
			var itemId = dij.processItemId;
			var hiddenRow = this._getRowForItemId(itemId);
			if (hiddenRow) {
				dojo.removeClass(hiddenRow, "hidden");//$NON-NLS-1$
			}
			this._destroyEditRow(event, itemId);
			this.importButton.disabled = false;
			this._disableToolbars(false);
			this.updatePagerDivLinksEnablement({count: this.currentTotalTemplates});
		},
		
		_handleSaveEdit: function(event){
			dojo.stopEvent(event);
			
			var dij = event.target;
			
			var itemId = dij.itemId;
			var stateId = dij.stateId;
			var nameDijit = dijit.byId(itemId + NAME_EDIT);
			var newName = nameDijit.attr('value'); //$NON-NLS-1$
			var newProcessId = dijit.byId(itemId + PROCESS_ID_EDIT).attr('value'); //$NON-NLS-1$
			if (newProcessId) {
				newProcessId = dojo.trim(newProcessId);
			}
			var newSummary = dijit.byId(itemId + SUMMARY_EDIT).attr('value'); //$NON-NLS-1$
			if (this._validateSave(newName, newProcessId)) {
				this.performSaveEdit(itemId, stateId, newName, newProcessId, newSummary);
				
				var row = this._getRowForItemId(itemId);
				dojo.removeClass(row, "hidden");//$NON-NLS-1$
				dojo.addClass(row, "updating");//$NON-NLS-1$
				var nameNode = dojo.byId(itemId + NAME);
				var changesPending = dojo.attr(nameNode, CHANGES_PENDING);
				if (changesPending === true) {
					dojo.attr(nameNode, NAME, newName);
					nameNode.innerHTML = newName;
				}
				dojo.byId(itemId + PROCESS_ID).innerHTML = newProcessId;
				var summaryNode = dojo.byId(itemId + SUMMARY);
				changesPending = dojo.attr(summaryNode, CHANGES_PENDING);
				if (changesPending === true) {
					dojo.attr(summaryNode, SUMMARY, newSummary);
					summaryNode.innerHTML = newSummary;
				}
				
				this._destroyEditRow(event, itemId);
				this.importButton.disabled = false;
				this._disableToolbars(false);
				this.updatePagerDivLinksEnablement({count: this.currentTotalTemplates});
			}
		},
		_validateSave: function(name, processId){
			if (!name || name === "") {//$NON-NLS-1$
				this.displayErrorMessage(this.messages.ManageTemplates_32, false);
				return false;
			}
			if (!processId || processId === "") {//$NON-NLS-1$
				this.displayErrorMessage(this.messages.ManageTemplates_33, false);
				return false;
			}
			return true;
		},
		_handleNavigate: function(href){
			var navigateTo = href.fragment;
			if (!navigateTo) {
				navigateTo = href.uri;
			}
			if (navigateTo.indexOf("IProcessDefinitionFileService") === -1 && navigateTo.indexOf("ProcessTemplateManagement" === -1)) {//$NON-NLS-1$ //$NON-NLS-2$            
				//if user editing, prompt to save
				if (this._isEditInProgress()) {
					if (confirm(this.messages.ManageTemplates_30)) {
						//user pressed OK to laeave page
						this._unregisterClickHandlers();
						this._destroyEditDijits(this.templateBeingEdited);
						this.templateBeingEdited = null;
						return false;
					} else {
						//veto the navigation
						return true;
					}
				}
			}
			//do not veto navigation if it is not to a different page
			return false;
		},
		_navigateAwayEvent: function(){
			if (this._isEditInProgress()) {
				return this.messages.ManageTemplates_31;
			}
			
			return false;
		},
		/**
		 * Remove the row from its table and destroy any edit dijits for the
		 * item with given itemId
		 * @param {Object} event
		 * @param {Object} itemId The itemId of the process template that the
		 * row was editing
		 */
		_destroyEditRow: function(event, itemId){
			this._unregisterClickHandlers();
			var editRow = this._getRow(event);
			editRow.parentNode.removeChild(editRow);
			this._destroyEditDijits(itemId);
			
		},
		_unregisterClickHandlers: function(){
			if (this.bodyClickHandler) {
				PlatformUI.getWorkbench().unregisterBodyClickHandler(this.bodyClickHandler);
			}
			if (this.onBeforeUnloadHandler) {
				PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandler);
			}
		},
		_destroyEditDijits: function(itemId){
			var nameDijit = dijit.byId(itemId + NAME_EDIT);
			if (nameDijit) {
				nameDijit.destroyRecursive();
			}
			
			var idDijit = dijit.byId(itemId + PROCESS_ID_EDIT);
			if (idDijit) {
				idDijit.destroyRecursive();
			}
			
			var summaryDijit = dijit.byId(itemId + SUMMARY_EDIT);
			if (summaryDijit) {
				summaryDijit.destroyRecursive();
			}
			
		},
		_enableSaveButton: function(itemId){
			var theButton = this._saveButtons[itemId];
			if (theButton) {
				theButton.disabled = false;
			}
		},
		_disableSaveButton: function(itemId){
			var theButton = this._saveButtons[itemId];
			if (theButton) {
				theButton.disabled = true;
			}
		},
		handleImportTemplateSuccess: function () {
			this.refresh({
				pageNum: this.queryPageNumber 
			});
		},
		handleDeleteTemplate: function(processItemId){
			if (confirm(this.messages.ImportTemplateDialog_9)) {
				this.displayPendingMessage(this.messages.ImportTemplateDialog_10);
				var srh = new ServiceResponseHandler(this, "handleDeleteTemplateSuccess", "handleDeleteTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.deleteProcessDefinition({
					uuid: processItemId
				}, srh);
			}
		},
		
		handleDeleteTemplateSuccess: function(processDefinitionDTO){
			this.refresh( {pageNum: this.queryPageNumber, error:"handleRefreshAfterDeleteError"}); //$NON-NLS-1$
		},
		
		handleRefreshAfterDeleteError : function (error) {
			//if the refresh fails because the number of templates in the repository is insufficient to warrant the
			//page, show the previous page of the query instead.
            if (this.queryPageNumber !== 0) {
            	this.queryPageNumber--;
            }
			window.location.hash = "#action=" + ProcessConstants.PREFIX + "manageTemplates&pageNum=" + this.queryPageNumber; //$NON-NLS-1$ //$NON-NLS-2$
			
		},
		
		handleDeleteTemplateError: function(error){
			var msg = document.createElement("div");//$NON-NLS-1$
			msg.appendChild(document.createTextNode(this.messages.ManageTemplates_16));
			if (error.message) {
				msg.appendChild(document.createElement("br"));//$NON-NLS-1$
				msg.appendChild(document.createElement("br")); //$NON-NLS-1$
				msg.appendChild(document.createTextNode(error.message));
			}
			this.displayErrorMessage(msg, true);
		},
		performSaveEdit: function(itemId, stateId, newName, newProcessId, newSummary){
			var msg = document.createElement("div");//$NON-NLS-1$
			msg.appendChild(document.createTextNode(dojo.string.substitute(this.messages.ManageTemplates_27, [newProcessId])));
			this.displayPendingMessage(msg, true);
			
			this.templateBeingEdited = SAVE_IN_PROGRESS;
			
			var srh = new ServiceResponseHandler(this, "handleSaveEditSuccess", "handleSaveEditError"); //$NON-NLS-1$ //$NON-NLS-2$
			var args = {
				itemId: itemId,
				stateId: stateId,
				name: newName,
				id: newProcessId,
				summary: newSummary
			};
			ProcessClient.postProcessDefinition(args, srh);
			
		},
		/**
		 * prompts user and cleans up state and dijits if appropriate
		 */
		_confirmLoseEdits: function(){
			if (this._isEditInProgress()) {
				if (!confirm(this.messages.ManageTemplates_34)) {
					//user does not want to continue deploying
					return false;
				} else {
					//reset template edit -- edits will be overwritten when 
					//deploy runs
					this._destroyEditDijits(this.templateBeingEdited);
					this._unregisterClickHandlers();
					this.templateBeingEdited = null;
					return true;
				}
			}
			return true;
		},
		/**
		 * Deploy templates and update the table.
		 */
		performDeployTemplates: function(e){
			dojo.stopEvent(e);
			if (!this._confirmLoseEdits()) {
				return false;
			}
			this.deployButton.disabled = true;
			this.importButton.disabled = true;
			dojox.data.dom.removeChildren(this.tbody);
			dojox.data.dom.removeChildren(this.messageDiv);
			this.messageDiv.appendChild(document.createTextNode(this.messages.ManageTemplates_13));
			var srh = new ServiceResponseHandler(this, "handleDeployTemplateSuccess", "handleDeployTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.deployPredefinedProcessDefinitions(srh);
		},
		handleSaveEditSuccess: function(response){
			this.clearMessage();
			this.templateBeingEdited = null;
			this.handleEditedProcess(response);
		},
		handleSaveEditError: function(error){
			this.templateBeingEdited = null;
			this.handleTemplateError(this.messages.ManageTemplates_25, error.message, false);
		},
		
		handleDeployTemplateSuccess: function(){
			this.isDeployed = true;
			this.refresh();
		},
		
		handleShowTemplatesError: function(error){
			var title = this.messages.ManageTemplates_18;
			this.handleTemplateError(title, error.message, true);
		},
		
		handleDeployTemplateError: function(error){
			var title = this.messages.ManageTemplates_14;
			this.handleTemplateError(title, error.message, true);
		},
		
		handleTemplateError: function(errorTitle, errorMessage, isBodyRemoved){
			if (isBodyRemoved) {
				dojox.data.dom.removeChildren(this.tbody);
			}
			//show the error
			var msg = document.createElement("div");//$NON-NLS-1$
			msg.appendChild(document.createTextNode(errorTitle));
			if (errorMessage) {
				msg.appendChild(document.createElement("br"));//$NON-NLS-1$
				msg.appendChild(document.createElement("br")); //$NON-NLS-1$
				msg.appendChild(document.createTextNode(errorMessage));
			}
			this.displayErrorMessage(msg, true);
			this.deployButton.disabled = false;
			this.importButton.disabled = false;
		},
		
		getTranslatedProcessDefinitionName: function(definition){
			var translatedName;
			
			if (definition.supportedLocales && definition.supportedLocales.length > 0) {
				// try the client locale next
				var locale = djConfig.locale;
				if (locale) {
					var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
					if (localeIndex != -1) {
						translatedName = definition.translatedNames[localeIndex];
					}
				}
				
				if (!translatedName) {
					// try any supported locales with the same language code
					if (locale && locale.length > 2) {
						var clientLocaleLang = locale.substring(0, 2);
						
						for (var i = 0; i < definition.supportedLocales.length; i++) {
							if (definition.supportedLocales[i].indexOf(clientLocaleLang) == 0) {
								translatedName = definition.translatedNames[i];
								if (translatedName && translatedName.length != 0) {
									break;
								}
							}
						}
					}
				}
			}
			
			// next try the default locale for the process definition
			if (!translatedName) {
				translatedName = definition.defaultName;
			}
			
			// finally default to the untranslated value
			if (!translatedName) {
				translatedName = definition.name;
			}
			
			return translatedName;
		},
		
		getTranslatedProcessDefinitionSummary: function(definition){
			var translatedSummary;
			
			if (definition.supportedLocales && definition.supportedLocales.length > 0) {
				// try the client locale next
				var locale = djConfig.locale;
				if (locale) {
					var localeIndex = dojo.indexOf(definition.supportedLocales, locale);
					if (localeIndex != -1) {
						translatedSummary = definition.translatedSummaries[localeIndex];
					}
				}
				
				if (!translatedSummary) {
					// try any supported locales with the same language code
					if (locale && locale.length > 2) {
						var clientLocaleLang = locale.substring(0, 2);
						
						for (var i = 0; i < definition.supportedLocales.length; i++) {
							if (definition.supportedLocales[i].indexOf(clientLocaleLang) == 0) {
								translatedSummary = definition.translatedSummaries[i];
								if (translatedSummary && translatedSummary.length != 0) {
									break;
								}
							}
						}
					}
				}
			}
			
			// next try the default locale for the process definition
			if (!translatedSummary) {
				translatedSummary = definition.defaultSummary;
			}
			
			// finally default to the untranslated value
			if (!translatedSummary) {
				translatedSummary = definition.summary;
			}
			
			return translatedSummary;
		},
		
		/**
		 * Update the row for the given process template with the new fields
		 * values.
		 *
		 * @param processDefinitionDto is a ProcessDefinitionDTO
		 */
		handleEditedProcess: function(processDefinitionDto){
			var newItemId = processDefinitionDto.itemId;
			var newProcessState = processDefinitionDto.stateId;
			var rowToUpdate = this._getRowForItemId(newItemId);
			dojo.attr(rowToUpdate, "stateId", newProcessState);//$NON-NLS-1$
			dojo.removeClass(rowToUpdate, "updating");//$NON-NLS-1$
		},
		
		createPagerDiv: function(){
			this.pagerDiv = document.createElement("div");//$NON-NLS-1$
			dojo.toggleClass(this.pagerDiv, "pager", true);//$NON-NLS-1$
			var prevSpan = document.createElement("span");//$NON-NLS-1$
			var prevLink = document.createElement("a");//$NON-NLS-1$
			prevLink.appendChild(document.createTextNode(this.messages.ManageTemplates_37));
			prevSpan.appendChild(prevLink);
			var disabledPrev = document.createElement("span");//$NON-NLS-1$
			disabledPrev.appendChild(document.createTextNode(this.messages.ManageTemplates_37));
			dojo.toggleClass(disabledPrev, "disabledText", true);//$NON-NLS-1$
			prevSpan.appendChild(disabledPrev);
			this.pagerDiv.appendChild(prevSpan);
			this.pagerDiv.prevSpan = prevSpan;
			this.pagerDiv.prevLink = prevLink;
			this.pagerDiv.appendChild(document.createTextNode(" | "));//$NON-NLS-1$
			var rangeSpan = document.createElement("span");//$NON-NLS-1$
			this.pagerDiv.appendChild(rangeSpan);
			this.pagerDiv.rangeSpan = rangeSpan;
			this.pagerDiv.appendChild(document.createTextNode(" | "));//$NON-NLS-1$
			var nextSpan = document.createElement("span");//$NON-NLS-1$
			var nextLink = document.createElement("a");//$NON-NLS-1$
			nextLink.appendChild(document.createTextNode(this.messages.ManageTemplates_38));
			nextSpan.appendChild(nextLink);
			var disabledNext = document.createElement("span");//$NON-NLS-1$
			disabledNext.appendChild(document.createTextNode(this.messages.ManageTemplates_38));
			dojo.toggleClass(disabledNext, "disabledText", true);//$NON-NLS-1$
			nextSpan.appendChild(disabledNext);
			this.pagerDiv.appendChild(nextSpan);
			this.pagerDiv.nextSpan = nextSpan;
			this.pagerDiv.nextLink = nextLink;
			this.tableControls.appendChild(this.pagerDiv);
			this.updatePagerDivLinks();
			this.connect(prevLink, "onclick", function(e){//$NON-NLS-1$
				dojo.stopEvent(e);
				document.location.href = e.target.href;
			});
			this.connect(nextLink, "onclick", function(e){//$NON-NLS-1$
				dojo.stopEvent(e);
				document.location.href = e.target.href;
			});
		},
		
		updatePagerDivLinks: function(){
			if (this.pagerDiv != null) {
				this.pagerDiv.prevLink.href = "#action=" + ProcessConstants.PREFIX + "manageTemplates&pageNum=" + (this.queryPageNumber - 1);//$NON-NLS-1$ //$NON-NLS-2$
				this.pagerDiv.nextLink.href = "#action=" + ProcessConstants.PREFIX + "manageTemplates&pageNum=" + (this.queryPageNumber + 1);//$NON-NLS-1$ //$NON-NLS-2$
			}
		},
		/*
		 * Find the row element that encloses the element that caused the event.
		 */
		_getRow: function(evt){
			var e = evt.target;
			while (e.parentNode) {
				if (e.tagName === "TR") { //$NON-NLS-1$
					return e;
				}
				e = e.parentNode;
			}
			return null;
		},
		/*
		 * Find the row for a given item id
		 */
		_getRowForItemId: function(itemId, table){
			var foundRows = dojo.query("tr[processItemId='" + itemId + "']");//$NON-NLS-1$ //$NON-NLS-2$
			if (foundRows.length > 0) {
				return foundRows[0];
			}
			return null;
		},
		_disablePagerLinks: function() {
            if (this.pagerDiv) {            
            	dojo.toggleClass(this.pagerDiv.prevSpan, "disabled", true);//$NON-NLS-1$
            	dojo.toggleClass(this.pagerDiv.nextSpan, "disabled", true);//$NON-NLS-1$
            }
		},
		_disableToolbars: function(disabled){
			for (var i = 0; i < this.actionToolbars.length; i++) {
				this.actionToolbars[i].disableToolbar(disabled);
			}
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this.actionToolbars.length; i++) {
				this.actionToolbars[i].destroyRecursive();
			}
			this.actionToolbars = [];
		},
		
		uninitialize: function(){
			this._destroyActionToolbars();
			
			this.inherited(arguments);
		}
	});
	
})();
