/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.data.dom"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojox.collections.Dictionary"); //$NON-NLS-1$
	dojo.require("dojox.string.BidiComplex"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
	dojo.require("jazz.app.ResourceLink"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.internal.AdminClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.EditorErrorHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.TRToolbar"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var AdminClient = com.ibm.team.repository.web.client.internal.AdminClient;
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var ResourceLink = jazz.app.ResourceLink;
	var MANAGER = "com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
	var USER_EDITOR = "com.ibm.team.repository.editUser"; //$NON-NLS-1$
	var ARCHIVED_USER_EDITOR = "com.ibm.team.repository.editArchivedUser"; //$NON-NLS-1$
	var PROJECT_AREA_EDITOR = "com.ibm.team.process.editProjectArea"; //$NON-NLS-1$
	var TEAM_AREA_EDITOR = "com.ibm.team.process.editTeamArea"; //$NON-NLS-1$
	var MSG_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#saveMsg"; //$NON-NLS-1$
	var TEAM_INVITATION_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#teamInvite"; //$NON-NLS-1$
	var KEY_RETURN = 13;
	var KEY_ENTER = 14;
	var MANAGE_ARCHIVED_LINK = "#action=com.ibm.team.process.manageArchivedProjectAreas"; //$NON-NLS-1$
	var MANAGE_ACTIVE_LINK = "#action=com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
	var DEFAULT_DISPLAY_MAX = 5;
	var SHOW_TEXT_LENGTH = 1024;
	var ON_CLICK = "onclick"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.AbstractProcessAreaEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		constructor: function(args){
			this._widgetCache = {};
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.isNew = args.itemId === ProcessConstants.EditorMode.NEW;
			this.initialize(args);
		},
		
		postCreate: function(){
		
			if (!this.isNew) {
				this._createTabs();
			}
			
			this.showingAllMembers = false;
			this.showingAllAdmins = false;
			this.connectHandles = [];
			this.addedRoles = [];
			this.removedRoles = [];
			this.definedRoles = [];
			this.originalDefinedRoles = [];
			this._actionToolbars = [];
			this.inputFields = [this.name, this.summary, this.description];
			this.connect(this.name, "onkeypress", function(e){ //$NON-NLS-1$
				if (e.keyCode === KEY_RETURN || e.keyCode === KEY_ENTER) {
					dojo.stopEvent(e);
					this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
				}
			});
			this.summary.viewElement = this.summaryView;
			this.summary.viewAllElement = this.summaryViewAll;
			this.summary.showAllLink = this.showAllSummaryLink;
			this.summary.showLessLink = this.showLessSummaryLink;
			this.summary.showingAll = false;
			this.description.viewElement = this.descriptionView;
			this.description.viewAllElement = this.descriptionViewAll;
			this.description.showAllLink = this.showAllDescriptionLink;
			this.description.showLessLink = this.showLessDescriptionLink;
			this.description.showingAll = false;
			this.editViewFields = [this.summary, this.description];
			this.connect(this.editViewTable, ON_CLICK, function(){ //$NON-NLS-1$
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
			});
			
			for (var i = 0; i < this.inputFields.length; i++) {
				this.connect(this.inputFields[i], "onkeyup", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.inputFields[i], "onchange", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			
			this.customConnect();
			
			this.connect(this.memberAddButton, ON_CLICK, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				if (this.allMembers == null) {
					this.allMembers = [];
				}
				this.addUserDialog(this.allMembers, "addNewMembers"); //$NON-NLS-1$
			});
			this.connect(this.adminAddButton, ON_CLICK, function(e){
				dojo.stopEvent(e);
				if (this.allAdmins == null) {
					this.allAdmins = [];
				}
				this.addUserDialog(this.allAdmins, "addNewAdmins"); //$NON-NLS-1$
			});
			
			this.connect(this.saveButton, ON_CLICK, "handleSave"); //$NON-NLS-1$
			this.connect(this.toggleDescLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				if (e.target.mode === ProcessConstants.EditorMode.PREVIEW) {
					this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				} else {
					this.toggleViewEditMode(ProcessConstants.EditorMode.PREVIEW);
					
				}
			});
			
			this.connect(this.previewName, "onmouseover", function(e){ //$NON-NLS-1$
				e.target.style.backgroundColor = "#FFFFCC"; //$NON-NLS-1$
			});
			this.connect(this.previewName, "onmouseout", function(e){ //$NON-NLS-1$
				e.target.style.backgroundColor = ProcessConstants.EMPTY;
			});
			this.connect(this.previewName, ON_CLICK, function(e){
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
			});
			this.connect(this.name, "onblur", function(e){ //$NON-NLS-1$
				this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
			});
			this.connect(this.showAllSummaryLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.summary.showingAll = true;
				this.summary.viewAllElement.style.display = ProcessConstants.INLINE;
				this.summary.showAllLink.style.display = ProcessConstants.NONE;
				this.summary.showLessLink.style.display = ProcessConstants.BLOCK;
			});
			this.connect(this.showLessSummaryLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.summary.showingAll = false;
				this.summary.viewAllElement.style.display = ProcessConstants.NONE;
				this.summary.showAllLink.style.display = ProcessConstants.BLOCK;
				this.summary.showLessLink.style.display = ProcessConstants.NONE;
			});
			this.connect(this.showAllDescriptionLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.description.showingAll = true;
				this.description.viewAllElement.style.display = ProcessConstants.INLINE;
				this.description.showAllLink.style.display = ProcessConstants.NONE;
				this.description.showLessLink.style.display = ProcessConstants.BLOCK;
			});
			this.connect(this.showLessDescriptionLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.description.showingAll = false;
				this.description.viewAllElement.style.display = ProcessConstants.NONE;
				this.description.showAllLink.style.display = ProcessConstants.BLOCK;
				this.description.showLessLink.style.display = ProcessConstants.NONE;
			});
			this.connect(this.showAllMembersLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllMembers = true;
				this.showAllMembersLink.style.display = ProcessConstants.NONE;
				this.showFewerMembersLink.style.display = ProcessConstants.BLOCK;
				for (var i = 0; i < this.memberArea.rows.length; i++) {
					this.memberArea.rows[i].style.display = ProcessConstants.EMPTY;
				}
			});
			this.connect(this.showFewerMembersLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllMembers = false;
				this.showAllMembersLink.style.display = ProcessConstants.BLOCK;
				this.showFewerMembersLink.style.display = ProcessConstants.NONE;
				for (var i = DEFAULT_DISPLAY_MAX; i < this.memberArea.rows.length; i++) {
					this.memberArea.rows[i].style.display = ProcessConstants.NONE;
				}
			});
			this.connect(this.showAllAdminsLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllAdmins = true;
				this.showAllAdminsLink.style.display = ProcessConstants.NONE;
				this.showFewerAdminsLink.style.display = ProcessConstants.BLOCK;
				for (var i = 0; i < this.adminArea.rows.length; i++) {
					this.adminArea.rows[i].style.display = ProcessConstants.EMPTY;
				}
			});
			this.connect(this.showFewerAdminsLink, ON_CLICK, function(e){
				dojo.stopEvent(e);
				this.showingAllAdmins = false;
				this.showAllAdminsLink.style.display = ProcessConstants.BLOCK;
				this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
				for (var i = DEFAULT_DISPLAY_MAX; i < this.adminArea.rows.length; i++) {
					this.adminArea.rows[i].style.display = ProcessConstants.NONE;
				}
			});
			
			this._refreshIcon.src = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/images/refresh16.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			this.refresh(false);
		},
		
		customConnect: function(){
			// Derived can override and add custom connects here
		
		},
		
		_createTabs: function(){
			this._saveParticipants = new dojox.collections.Dictionary();
			this._tabs = [];
			
			this.createTab(this.messages.ProjectAreaEditor_OverviewTabLabel, ProcessConstants.TabEnum.OVERVIEW, function(){
				/* No call back needed for overview tab 
				 * Just return an empty object to represent the tab
				 */
				return {};
			});
			this.createTab(this.messages.ProjectAreaEditor_RolesTabLabel, ProcessConstants.TabEnum.ROLES, this._createRoles);
			this.createTab(this.messages.ProjectAreaEditor_PermissionTabLabel, ProcessConstants.TabEnum.PERMISSIONS, this._createPermissions);
			
			this.createCustomTabs();
			
			dojo.toggleClass(this.tabSection.childNodes[0], "selected", true); //$NON-NLS-1$
			this.selectedTab = ProcessConstants.TabEnum.OVERVIEW;
		},
		
		createCustomTabs: function(){
			// Derived can override and add custom widgets here
			// using the createTab() function
		
		},
		
		createTab: function(text, tabId, createCallBack, idOfTabToInsertBefore){
			var link = document.createElement("a"); //$NON-NLS-1$
			link.className = "tab"; //$NON-NLS-1$
			link.href = "#"; //$NON-NLS-1$
			link.tabId = tabId;
			link.createTab = createCallBack;
			var topWrapper = document.createElement("div"); //$NON-NLS-1$
			topWrapper.className = "topWrapper"; //$NON-NLS-1$
			var topBorder = document.createElement("div"); //$NON-NLS-1$
			topBorder.className = "topBorder"; //$NON-NLS-1$
			topWrapper.appendChild(topBorder);
			var corners = document.createElement("div"); //$NON-NLS-1$
			corners.className = "corners"; //$NON-NLS-1$
			topWrapper.appendChild(corners);
			link.appendChild(topWrapper);
			var innerWrapper = document.createElement("div"); //$NON-NLS-1$
			innerWrapper.className = "innerWrapper"; //$NON-NLS-1$
			var title = document.createElement("div"); //$NON-NLS-1$
			title.className = "title"; //$NON-NLS-1$
			title.appendChild(document.createTextNode(text));
			title.tabId = tabId;
			innerWrapper.appendChild(title);
			link.appendChild(innerWrapper);
			if (idOfTabToInsertBefore !== undefined) {
				this.tabSection.insertBefore(link, this._tabs[idOfTabToInsertBefore]);
			} else {
				this.tabSection.appendChild(link);
			}
			
			this.connect(link, ON_CLICK, "_onTabClick"); //$NON-NLS-1$
			this._tabs[tabId] = link;
		},
		
		
		_createPermissions: function(){
		
			var editor = new com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeEditor({
				editor: this
			});
			this.permissionEditor = editor;
			this.twoColumnMainColumn.appendChild(editor.domNode);
			return editor;
		},
		
		_getProcessAreaStore: function(){
			// Must be overridden by the project and team are editors
			// To supply the correct type of store for permisions/timelines
		},
		
		_handleCreateStoreError: function(error, permissionsScopeContext){
			switch (permissionsScopeContext) {
				case ProcessConstants.PermissionsScopeContext.DEV_LINES:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingDevelopmentLines);
					break;
				case ProcessConstants.PermissionsScopeContext.ITERATION_TYPES:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingIterationTypes);
					break;
				case ProcessConstants.PermissionsScopeContext.ITERATIONS:
					this.handleServerResponseError(error, this.messages.AbstractProcessAreaEditor_ErrorFetchingIterations);
					break;
			}
			
		},
		
		_createRoles: function(){
		
			var editor = new com.ibm.team.process.web.ui.internal.admin.projects.RolesEditor({
				editor: this
			});
			this.rolesEditor = editor;
			this.twoColumnMainColumn.appendChild(editor.domNode);
			return editor;
		},
		
		_onTabClick: function(event){
			dojo.stopEvent(event);
			var selectedTab;
			for (var i = 0; i < this.tabSection.childNodes.length; i++) {
				var tabId = this.tabSection.childNodes[i].tabId;
				if (tabId == event.target.tabId) {
					dojo.toggleClass(this.tabSection.childNodes[i], "selected", true); //$NON-NLS-1$
					this.tabSection.childNodes[i].removeAttribute('href'); //$NON-NLS-1$ 
					selectedTab = tabId;
				} else {
					dojo.toggleClass(this.tabSection.childNodes[i], "selected", false); //$NON-NLS-1$
					this.tabSection.childNodes[i].href = "#"; //$NON-NLS-1$
				}
			}
			if (this.selectedTab === selectedTab) {
				return; //tab already selected
			}
			
			// cache the current tab
			if (!this._widgetCache[this.selectedTab]) {
				this._cacheCurrentChildren(this.selectedTab);
			}
			dojox.data.dom.removeChildren(this.twoColumnMainColumn);
			this.selectedTab = selectedTab;
			
			// Only show the team area hierarchy on the overview tab
			if (this.selectedTab === ProcessConstants.TabEnum.OVERVIEW) {
				this.teamAreaHierarchy.style.display = "block"; //$NON-NLS-1$
			} else {
				this.teamAreaHierarchy.style.display = "none"; //$NON-NLS-1$
			}
			
			if (!this._widgetCache[selectedTab]) {
				var tabLink = this._tabs[selectedTab];
				//first time going to the tab so invoke the creation function
				tabLink.mainPage = tabLink.createTab.call(this);
				
			} else {
				var theTab = this._tabs[selectedTab].mainPage;
				if (theTab && dojo.isFunction(theTab.activateTab)) {
					theTab.activateTab.call(theTab);
				}
				
			}
			
			//replaceChild
			if (this._widgetCache[selectedTab]) {
				this._switchCachedTab(selectedTab);
			}
			this.showBreadcrumbs();
			
		},
		
		_switchCachedTab: function(selectedTab){
			dojo.forEach(this._widgetCache[selectedTab], function(child){
				this.twoColumnMainColumn.appendChild(child);
			}, this);
		},
		
		_cacheCurrentChildren: function(selectedTab){
			var children = [];
			for (var i = 0; i < this.twoColumnMainColumn.childNodes.length; i++) {
				children[i] = this.twoColumnMainColumn.childNodes[i];
			}
			this._widgetCache[selectedTab] = children;
		},
		
		addUserDialog: function(filterUsers, callbackFunction){
			var userFilter = [];
			for (var i = 0; i < filterUsers.length; i++) {
				userFilter.push({
					'itemId': filterUsers[i].itemId //$NON-NLS-1$
				});
			}
			var userPicker = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({
				'disableUsers': userFilter //$NON-NLS-1$
			});
			this.connect(userPicker, "onAdd", callbackFunction); //$NON-NLS-1$
		},
		
		refresh: function(refreshClicked){
			if (!this.navigateAwayHandle) {
				this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
				this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this.navigateAwayEvent), /*priority*/ 10000);
			}
			
			this.clearState(refreshClicked);
			this.deferredSaveCount = 0;
			if (this.isNew) {
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				this.populateMembers([]);
				this.populateAdmins([]);
				setTimeout(dojo.hitch(this.name, function(){
					try {
						this.select();
					} catch (error) {
						// If the text can't be selected...ignore the error
					}
				}), 250); //$NON-NLS-1$
			} else {
				dojox.data.dom.removeChildren(this.memberArea);
				dojox.data.dom.removeChildren(this.adminArea);
			}
			
			this.customRefresh(refreshClicked);
			this.checkForSuccessMsg();
		},
		
		_handleNavigate: function(urlObj){
			if (this.changesPending()) {
				if (!confirm(this.messages.ProjectAreaEditor_2)) {
					return true; //veto the navigate
				}
			}
			//move away from the editor
			this._unregisterHandlers();
			return false;
		},
		
		navigateAwayEvent: function(){
			return this.changesPending() ? this.messages.ProjectAreaEditor_3 : false;
		},
		
		_unregisterHandlers: function(){
			PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
			PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
		},
		
		checkForSuccessMsg: function(){
			var msgCookie = dojo.cookie(MSG_COOKIE_NAME);
			if (msgCookie) {
				this.displaySuccessMessage(msgCookie, true);
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(MSG_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		checkForTeamInvitation: function(){
			var inviteCookie = dojo.cookie(TEAM_INVITATION_COOKIE_NAME);
			if (inviteCookie) {
				this.chooseTeamInvitees(dojo.fromJson(inviteCookie));
				
				var now = new Date();
				now.setTime(now.getTime() - 1);
				dojo.cookie(TEAM_INVITATION_COOKIE_NAME, ProcessConstants.EMPTY, {
					expires: now
				});
			}
		},
		
		clearState: function(refreshClicked){
			delete this.errObj;
			this.setDirty(false);
			this.pendingMemberChanges = {};
			this.pendingAdminChanges = {};
			this.allMembers = [];
			this.addedRoles = [];
			this.removedRoles = [];
			this.definedRoles = [];
			this.originalDefinedRoles = [];
			this.allAdmins = [];
			this._clearMessage();
			this.name.value = ProcessConstants.EMPTY;
			this.summary.value = ProcessConstants.EMPTY;
			this.description.value = ProcessConstants.EMPTY;
			dojox.data.dom.removeChildren(this.memberArea);
			dojox.data.dom.removeChildren(this.adminArea);
			for (var i = 0; i < this.inputFields.length; i++) {
				this.inputFields[i].changePending = false;
			}
			
			if (refreshClicked) {
				this._destroySaveParticipants();
				this._saveParticipants = new dojox.collections.Dictionary();
			}
			if (this.sharedStore) {
				delete this.sharedStore;
			}
			this._destroyActionToolbars();
			
		},
		
		_clearMessage: function(){
			dojox.data.dom.removeChildren(this.messageBox);
			dojox.data.dom.removeChildren(this.longMessageBox);
			this.messageBox.className = ProcessConstants.EMPTY;
			this.longMessageBox.className = ProcessConstants.EMPTY;
		},
		
		handleFetchError: function(error){
			error.priority = ProcessConstants.ERROR_PRIORITY_HIGH;
			if (error.status == ProcessConstants.SC_FORBIDDEN) {
				// Hide everything in the editor
				this.primaryFieldContainer.style.display = ProcessConstants.NONE;
				this.tabSection.style.display = ProcessConstants.NONE;
				this.contentWrapper.style.display = ProcessConstants.NONE;
				// Eliminate the stock message from core.
				error.message = ""; //$NON-NLS-1$ 
			}
			var message = this.getFetchErrorMessage(error);
			this.handleServerResponseError(error, message, [ProcessConstants.PERMISSION_DENIED_EXCEPTION]);
		},
		
		handleServerResponseSuccess: function(response){
			this.deferredSaveCount--;
			if (this.deferredSaveCount <= 0) {
				if (!this.errObj) { //no more outstanding saves and not already showing an error
					this.refresh(false);
					this.displaySuccessMessage(this.messages.ProjectAreaEditor_30, true);
				} else { //all the deferred saves are complete. Report the previously hit error
					var msg = new com.ibm.team.process.web.ui.internal.admin.projects.EditorErrorHandler(this.errObj);
					if (this.errObj.priority > ProcessConstants.ERROR_PRIORITY_WARNING) {
						this.displayLongErrorMessage(msg.domNode);
					} else {
						this.displayLongWarningMessage(msg.domNode);
					}
					
				}
			}
		},
		
		handleServerResponseError: function(error, optionalHeaderMessage, optionalExceptionClassesToIgnore){
			this.deferredSaveCount--;
			
			// If the error doesn't have a priority...give it a really low one. 
			if (!error.priority) {
				error.priority = ProcessConstants.ERROR_PRIORITY_LOW;
			}
			
			if (!this.errObj || error.priority > this.errObj.priority) {
				this.errObj = dojo.mixin({}, error);
				this.errObj.headerMessage = optionalHeaderMessage;
				this.errObj.exceptionClassesToIgnore = optionalExceptionClassesToIgnore;
			}
			
			if (this.deferredSaveCount <= 0) { //no more outstanding saves and not already showing an error
				var msg = new com.ibm.team.process.web.ui.internal.admin.projects.EditorErrorHandler(this.errObj);
				this.displayLongErrorMessage(msg.domNode);
			}
		},
		
		handleServerResponseWarning: function(error, optionalHeaderMessage){
			this.deferredSaveCount--;
			if (this.errObj) {
				return;
			}
			
			this.errObj = dojo.mixin({}, error);
			this.errObj.priority = ProcessConstants.ERROR_PRIORITY_WARNING;
			this.errObj.headerMessage = optionalHeaderMessage;
			if (this.deferredSaveCount <= 0) { //no more outstanding saves and not already showing an error
				var msg = new com.ibm.team.process.web.ui.internal.admin.projects.EditorErrorHandler(this.errObj);
				this.displayLongWarningMessage(msg.domNode);
			}
		},
		
		togglePrimaryField: function(mode){
			if (mode === ProcessConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessConstants.NONE;
				dojox.data.dom.removeChildren(this.previewName);
				this.previewName.appendChild(document.createTextNode(this.name.value || this.getPrimaryFieldLabel()));
				this.previewName.style.display = ProcessConstants.EMPTY;
			} else if (mode === ProcessConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessConstants.NONE;
				this.name.style.display = ProcessConstants.EMPTY;
				this.name.focus();
				this.name.select();
				this.displayMessage(ProcessConstants.EMPTY, ProcessConstants.EMPTY);
			}
		},
		
		toggleViewEditMode: function(mode){
			this.toggleDescLink.mode = mode;
			if (mode === ProcessConstants.EditorMode.PREVIEW) {
				dojo.forEach(this.editViewFields, function(field){
					field.style.display = ProcessConstants.NONE;
					dojox.data.dom.removeChildren(field.viewElement);
					var previewString = field.value.substring(0, SHOW_TEXT_LENGTH);
					var hiddenString = field.value.substring(SHOW_TEXT_LENGTH);
					if (field.value.length > SHOW_TEXT_LENGTH) {
						var spaceIndex = hiddenString.indexOf(" "); //$NON-NLS-1$
						var newlineIndex = hiddenString.indexOf("\n"); //$NON-NLS-1$
						// if there is no good point to break the string in hiddenString, just show the whole thing
						if (spaceIndex === -1 && newlineIndex === -1) {
							previewString += hiddenString;
							hiddenString = ProcessConstants.EMPTY;
						} else if (newlineIndex === -1 || (spaceIndex !== -1 && spaceIndex < newlineIndex)) {
							previewString += hiddenString.substring(0, spaceIndex);
							hiddenString = hiddenString.substring(spaceIndex);
						} else if (spaceIndex === -1 || (newlineIndex !== -1 && newlineIndex < spaceIndex)) {
							previewString += hiddenString.substring(0, newlineIndex);
							hiddenString = hiddenString.substring(newlineIndex);
						}
					}
					var strings = previewString.split(/\n/);
					for (var i = 0; i < strings.length; i++) {
						if (i > 0) {
							field.viewElement.appendChild(document.createElement(ProcessConstants.BR));
						}
						if (strings[i].length > 0) {
							field.viewElement.appendChild(document.createTextNode(strings[i]));
						}
					}
					field.viewElement.style.display = ProcessConstants.EMPTY;
					dojox.data.dom.removeChildren(field.viewAllElement);
					if (hiddenString != null && hiddenString !== ProcessConstants.EMPTY) {
						strings = hiddenString.split(/\n/);
						for (i = 0; i < strings.length; i++) {
							if (i > 0) {
								field.viewAllElement.appendChild(document.createElement(ProcessConstants.BR));
							}
							if (strings[i].length > 0) {
								field.viewAllElement.appendChild(document.createTextNode(strings[i]));
							}
						}
						if (field.showingAll) {
							field.viewAllElement.style.display = ProcessConstants.INLINE;
							field.showLessLink.style.display = ProcessConstants.BLOCK;
							field.showAllLink.style.display = ProcessConstants.NONE;
						} else {
							field.viewAllElement.style.display = ProcessConstants.NONE;
							field.showLessLink.style.display = ProcessConstants.NONE;
							field.showAllLink.style.display = ProcessConstants.BLOCK;
						}
					}
				});
				dojox.data.dom.removeChildren(this.toggleDescLink);
				this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_8));
			} else if (mode === ProcessConstants.EditorMode.EDIT) {
				dojox.data.dom.removeChildren(this.toggleDescLink);
				this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_9));
				dojo.forEach(this.editViewFields, function(field){
					field.viewElement.style.display = ProcessConstants.NONE;
					field.viewAllElement.style.display = ProcessConstants.NONE;
					field.style.display = ProcessConstants.EMPTY;
					field.showAllLink.style.display = ProcessConstants.NONE;
					field.showLessLink.style.display = ProcessConstants.NONE;
				});
			}
		},
		
		populateProcessAreaData: function(data){
			this.stateId = data.stateId;
			this._isArchived = data.archived;
			if (!data.archived) {
				this.createChildButton.style.display = ProcessConstants.EMPTY;
			}
			this.name.value = data.name;
			this.name.savedValue = data.name;
			this.togglePrimaryField(ProcessConstants.EditorMode.PREVIEW);
			this.summary.value = data.summary;
			this.summary.savedValue = data.summary;
			this.description.value = data.description;
			this.description.savedValue = data.description;
			
			if (data.description) {
				this.toggleViewEditMode(ProcessConstants.EditorMode.PREVIEW);
			} else {
				this.toggleViewEditMode(ProcessConstants.EditorMode.EDIT);
			}
			this.allProcessRoles = data.processDTO.roles;
			this.definedRoles = [];
			dojo.forEach(this.allProcessRoles, function(role){
				if (role.defined === true) {
					this.definedRoles.push(role);
					// Make a copy of all the defined role ids so they can be deleted.
					this.originalDefinedRoles.push({
						id: role.id
					});
				}
			}, this);
			
			if (this.rolesEditor) {
				this.rolesEditor.refresh();
			}
			
			this.allMembers = data.members;
			this.allAdmins = data.admins;
			this.populateMembers(this.allMembers);
			this.populateAdmins(this.allAdmins);
			this.checkForTeamInvitation();
		},
		
		showBreadcrumbs: function(){
			dojox.data.dom.removeChildren(this.breadcrumbs);
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = this._isArchived ? MANAGE_ARCHIVED_LINK : MANAGE_ACTIVE_LINK;
			link.appendChild(document.createTextNode(this._isArchived ? this.messages.ProjectAreaEditor_10 : this.messages.ProjectAreaEditor_11));
			this.breadcrumbs.appendChild(link);
			var span = document.createElement("span"); //$NON-NLS-1$
			span.appendChild(document.createTextNode(">")); //$NON-NLS-1$
			this.breadcrumbs.appendChild(span);
			
			this.customShowBreadcrumbs();
			
		},
		
		getAllProcessRoles: function(){
			var allRoles = [];
			// Add in the defined roles
			dojo.forEach(this.definedRoles, function(role){
				allRoles.push(role);
			});
			
			// Now add in the inherited roles
			dojo.forEach(this.allProcessRoles, function(role){
				if (role.id === ProcessConstants.DEFAULT_ROLE_ID) {
					// Default role is always first.
					allRoles.unshift(role);
				} else if (role.defined === false) {
					// Only add in inherited roles
					allRoles.push(role);
				}
			});
			
			return allRoles;
		},
		
		customShowBreadcrumbs: function(){
			// Derived can override and add custom bread crumbs
		
		},
		
		populateTeamAreaHierarchy: function(data){
			dojox.data.dom.removeChildren(this.teamAreaHierarchyContent);
			var div = document.createElement(ProcessConstants.DIV);
			div.className = "hierarchyElement selected"; //$NON-NLS-1$
			div.appendChild(document.createTextNode(data.name));
			this.teamAreaHierarchyContent.appendChild(div);
			if (data.children != null) {
				this.displayProcessChildren(data.children, 1);
			}
		},
		
		displayProcessChildren: function(children, indent){
			children = children.sort(function(a, b){
				return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
			});
			for (var i = 0; i < children.length; i++) {
				var div = document.createElement(ProcessConstants.DIV);
				div.className = "hierarchyElement"; //$NON-NLS-1$
				var link = document.createElement("a"); //$NON-NLS-1$
				link.tabIndex = 3;
				var openEditorUri = "#action=" + TEAM_AREA_EDITOR + "&itemId=" + children[i].itemId + "&projectAreaItemId=" + this.projectAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				link.href = this._getServerUrl() + net.jazz.ajax._contextRoot + "/process/project-areas/" + this.projectAreaItemId + "/team-areas/" + children[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$  
				
				link.appendChild(document.createTextNode(children[i].name));
				var rl = new ResourceLink({
					'presentationUri': openEditorUri//$NON-NLS-1$
				}, link);
				div.appendChild(link);
				div.style.paddingLeft = (indent * 15) + "px"; //$NON-NLS-1$
				this.teamAreaHierarchyContent.appendChild(div);
				if (children[i].children != null) {
					this.displayProcessChildren(children[i].children, indent + 1);
				}
			}
		},
		
		handleTeamAreaHierarchyFetchError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_12);
		},
		
		populateMembers: function(members){
			this.populateUsers(members, this.memberHeader, this.memberArea, !this.isNew, this.showingAllMembers, "memberRemoveHandler", "processRoleHandler", "teamInviteHandler"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
			if (members != null && members.length > DEFAULT_DISPLAY_MAX) {
				if (this.showingAllMembers) {
					this.showFewerMembersLink.style.display = ProcessConstants.BLOCK;
					this.showAllMembersLink.style.display = ProcessConstants.NONE;
				} else {
					this.showFewerMembersLink.style.display = ProcessConstants.NONE;
					this.showAllMembersLink.style.display = ProcessConstants.BLOCK;
				}
			} else {
				this.showFewerMembersLink.style.display = ProcessConstants.NONE;
				this.showAllMembersLink.style.display = ProcessConstants.NONE;
			}
		},
		
		populateAdmins: function(admins){
			this.populateUsers(admins, this.adminHeader, this.adminArea, false, this.showingAllAdmins, "adminRemoveHandler"); //$NON-NLS-1$
			if (admins != null && admins.length > DEFAULT_DISPLAY_MAX) {
				if (this.showingAllAdmins) {
					this.showFewerAdminsLink.style.display = ProcessConstants.BLOCK;
					this.showAllAdminsLink.style.display = ProcessConstants.NONE;
				} else {
					this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
					this.showAllAdminsLink.style.display = ProcessConstants.BLOCK;
				}
			} else {
				this.showFewerAdminsLink.style.display = ProcessConstants.NONE;
				this.showAllAdminsLink.style.display = ProcessConstants.NONE;
			}
		},
		
		populateUsers: function(users, header, userArea, isNotNew, showAll, removeHandler, processRoleHandler, teamInviteHandler){
			dojox.data.dom.removeChildren(header);
			var tr = document.createElement("tr"); //$NON-NLS-1$
			tr.className = "headerLineRow"; //$NON-NLS-1$
			var th = document.createElement("th"); //$NON-NLS-1$
			if (dojo.isIE) {
				th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			}
			th.className = "memberName"; //$NON-NLS-1$
			tr.appendChild(th);
			if (isNotNew) {
				th = document.createElement("th"); //$NON-NLS-1$
				th.className = "memberRoles"; //$NON-NLS-1$
				if (dojo.isIE) {
					th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
				}
				tr.appendChild(th);
			} else {
				th = document.createElement("th"); //$NON-NLS-1$
				th.className = "memberMail"; //$NON-NLS-1$
				if (dojo.isIE) {
					th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
				}
				tr.appendChild(th);
			}
			th = document.createElement("th"); //$NON-NLS-1$
			th.className = "iconNode"; //$NON-NLS-1$
			dojo.addClass(th, ProcessConstants.CSSClass.ACTION_COLUMN);
			if (dojo.isIE) {
				th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			}
			tr.appendChild(th);
			header.appendChild(tr);
			tr = document.createElement("tr"); //$NON-NLS-1$
			th = document.createElement("th"); //$NON-NLS-1$
			th.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_18));
			th.className = "memberName"; //$NON-NLS-1$
			tr.appendChild(th);
			if (isNotNew) {
				th = document.createElement("th"); //$NON-NLS-1$
				th.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_19));
				th.className = "memberRoles"; //$NON-NLS-1$
				tr.appendChild(th);
			} else {
				th = document.createElement("th"); //$NON-NLS-1$
				th.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_20));
				th.className = "memberMail"; //$NON-NLS-1$
				tr.appendChild(th);
			}
			th = document.createElement("th"); //$NON-NLS-1$
			th.className = "iconNode"; //$NON-NLS-1$
			dojo.addClass(th, ProcessConstants.CSSClass.ACTION_COLUMN);
			dojo.style(th, "width", "15%"); //$NON-NLS-1$ //$NON-NLS-2$
			th.appendChild(document.createTextNode(this.messages.AbstractProcessAreaEditor_UserTableActionsHeader));
			tr.appendChild(th);
			
			header.appendChild(tr);
			dojox.data.dom.removeChildren(userArea);
			if (users != null && users.length > 0) {
				for (var i = 0; i < users.length; i++) {
					tr = document.createElement("tr"); //$NON-NLS-1$
					tr.userObj = users[i];
					var td = document.createElement("td"); //$NON-NLS-1$
					td.className = "memberName"; //$NON-NLS-1$
					var link = document.createElement("a"); //$NON-NLS-1$
					var presentationUri;
					if (users[i].archived) {
						presentationUri = "#action=" + ARCHIVED_USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
					} else {
						presentationUri = "#action=" + USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
					}
					link.href = this._getServerUrl() + net.jazz.ajax._contextRoot + "/users/" + users[i].userId; //$NON-NLS-1$ 
					var rl = new ResourceLink({
						'presentationUri': presentationUri //$NON-NLS-1$
					}, link);
					
					link.appendChild(document.createTextNode(users[i].name));
					td.appendChild(link);
					
					this.connectHandles.push(dojo.connect(link, "onfocus", tr, function(e){ //$NON-NLS-1$
						dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, true);
					}));
					this.connectHandles.push(dojo.connect(link, "onblur", tr, function(e){ //$NON-NLS-1$
						dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, false);
					}));
					
					tr.appendChild(td);
					if (isNotNew) {
						td = document.createElement("td"); //$NON-NLS-1$
						td.className = "memberRoles"; //$NON-NLS-1$
						var roleStr = ProcessConstants.EMPTY;
						if (users[i].processRoles != null) {
							users[i].savedProcessRoles = users[i].processRoles;
							var roleIds = [];
							for (var j = 0; j < users[i].processRoles.length; j++) {
								// hide the default role from the display
								if (users[i].processRoles[j].id != "default") { //$NON-NLS-1$
									roleIds.push(users[i].processRoles[j].label);
								}
							}
							roleStr = roleIds.join(", "); //$NON-NLS-1$
						}
						if (dojo.isIE && roleStr === ProcessConstants.EMPTY) {
							roleStr = " "; //$NON-NLS-1$
						}
						td.appendChild(document.createTextNode(roleStr));
						tr.roleDisplay = td;
					} else {
						td = document.createElement("td"); //$NON-NLS-1$
						td.className = "memberMail"; //$NON-NLS-1$
						if (users[i].emailAddress) {
							link = document.createElement("a"); //$NON-NLS-1$
							//Do not format the email address code, just the display String
							link.href = "mailto:" + users[i].emailAddress; //$NON-NLS-1$
							var emailAddress = dojox.string.BidiComplex.createDisplayString(users[i].emailAddress, "EMAIL"); //$NON-NLS-1$
							link.appendChild(document.createTextNode(emailAddress));
							this.connectHandles.push(dojo.connect(link, "onfocus", tr, function(e){ //$NON-NLS-1$
								dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, true);
							}));
							this.connectHandles.push(dojo.connect(link, "onblur", tr, function(e){ //$NON-NLS-1$
								dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, false);
							}));
							
							td.appendChild(link);
						} else if (dojo.isIE) {
							td.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
						}
						tr.mailDisplay = td;
					}
					tr.appendChild(td);
					td = document.createElement("td"); //$NON-NLS-1$
					td.className = "iconNode"; //$NON-NLS-1$
					var trToolbar = new com.ibm.team.process.web.ui.internal.TRToolbar();
					td.appendChild(trToolbar.domNode);
					this._actionToolbars.push(trToolbar);
					
					if (isNotNew && teamInviteHandler != null) {
						var teamInviteAction = {};
						teamInviteAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite.gif"); //$NON-NLS-1$  //$NON-NLS-2$
						teamInviteAction.label = this.messages.ProjectAreaEditor_40;
						trToolbar.addButton(this, teamInviteHandler, teamInviteAction);
					}
					if (isNotNew) {
						var processRolesAction = {};
						processRolesAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles.gif"); //$NON-NLS-1$  //$NON-NLS-2$
						processRolesAction.label = this.messages.ProjectAreaEditor_21;
						trToolbar.addButton(this, processRoleHandler, processRolesAction);
					}
					this.addRemoveIcon(trToolbar, removeHandler);
					tr.appendChild(td);
					this.connectHandles.push(dojo.connect(tr, "onmouseover", tr, function(e){ //$NON-NLS-1$
						dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, true);
					}));
					this.connectHandles.push(dojo.connect(tr, "onmouseout", function(e){ //$NON-NLS-1$
						dojo.toggleClass(this, ProcessConstants.CSSClass.TABLE_ROW_SELECTED, false);
					}));
					if (!showAll && i >= DEFAULT_DISPLAY_MAX) {
						tr.style.display = ProcessConstants.NONE;
					}
					userArea.appendChild(tr);
				}
			}
		},
		
		addRemoveIcon: function(trToolbar, removeHandler){
			var removeAction = {};
			removeAction.imgSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$  //$NON-NLS-2$
			removeAction.label = this.messages.ProjectAreaEditor_22;
			trToolbar.addButton(this, removeHandler, removeAction);
		},
		
		memberRemoveHandler: function(e){
			dojo.stopEvent(e);
			if (this.pendingMemberChanges.remove == null) {
				this.pendingMemberChanges.remove = [];
			}
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			var itemId = selectedUser.itemId;
			
			this.pendingMemberChanges.remove.push(itemId);
			for (var j = 0; j < this.allMembers.length; j++) {
				if (itemId === this.allMembers[j].itemId) {
					this.allMembers.splice(j, 1);
					break;
				}
			}
			if (this.pendingMemberChanges.add != null) {
				for (j = 0; j < this.pendingMemberChanges.remove.length; j++) {
					if (this.pendingMemberChanges.add[j] == itemId) {
						this.pendingMemberChanges.add.splice(j, 1);
						break;
					}
				}
			}
			this.setDirty(this.changesPending());
			this.populateMembers(this.allMembers);
		},
		
		processRoleHandler: function(e){
			dojo.stopEvent(e);
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			this.processRoleRow = rowNode;
			
			var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
			var roleObj = {};
			roleObj.allRoles = this.allProcessRoles;
			roleObj.member = selectedUser;
			var processRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(roleObj, workbenchNode);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_23,
				contentNode: processRoleDialog.domNode,
				width: "52em", //$NON-NLS-1$
				destroyContents: true,
				execute: function(selectedRoles){
					var roleIds = [];
					for (var i = 0; i < selectedRoles.length; i++) {
						// hide the default role from the display
						if (selectedRoles[i].id != "default") { //$NON-NLS-1$
							roleIds.push(selectedRoles[i].label);
						}
					}
					var roleString = roleIds.join(", "); //$NON-NLS-1$
					var selectedRow = this.targetObj.processRoleRow;
					dojox.data.dom.removeChildren(selectedRow.roleDisplay);
					selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
					selectedRow.userObj.processRoles = selectedRoles;
					var roleChanged = false;
					if (selectedRoles.length == selectedRow.userObj.savedProcessRoles.length) {
						for (var j = 0; j < selectedRoles.length; j++) {
							if (selectedRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
								roleChanged = true;
								break;
							}
						}
					} else {
						roleChanged = true;
					}
					if (roleChanged) {
						var roleArray = [];
						for (j = 0; j < selectedRow.userObj.processRoles.length; j++) {
							roleArray.push(selectedRow.userObj.processRoles[j].id);
						}
						if (this.targetObj.pendingMemberChanges.roles == null) {
							this.targetObj.pendingMemberChanges.roles = {};
						}
						this.targetObj.pendingMemberChanges.roles[selectedRow.userObj.itemId] = roleArray;
					} else {
						if (this.targetObj.pendingMemberChanges.roles != null) {
							delete this.targetObj.pendingMemberChanges.roles[selectedRow.userObj.itemId];
							var roleChanges = false;
							for (j in this.targetObj.pendingMemberChanges.roles) {
								roleChanges = true;
								break;
							}
							if (!roleChanges) {
								delete this.targetObj.pendingMemberChanges.roles;
							}
						}
					}
					if (this.targetObj.changesPending()) {
						this.targetObj.saveButton.disabled = false;
					} else {
						this.targetObj.saveButton.disabled = true;
					}
				}
			});
			
			processRoleDialog.startup();
			dialogWidget.targetObj = this;
			dialogWidget.processRoleDialogObj = processRoleDialog;
			this.connectHandles.push(dojo.connect(processRoleDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(processRoleDialog.finishButton, ON_CLICK, dialogWidget, function(e){
				this.execute(this.processRoleDialogObj.getChosenRoles());
				this.close();
			}));
		},
		
		teamInviteHandler: function(e){
			dojo.stopEvent(e);
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			this.customizeAndSendTeamInvitation([rowNode.userObj.itemId], rowNode.userObj, false);
		},
		
		createInvitationPropertiesString: function(user, repoLink){
			return dojo.string.substitute("teamRepository=${0}\nuserId=${1}\nuserName=${2}\nprojectAreaName=${3}", [repoLink, user.userId, user.name, this.name.value]); //$NON-NLS-1$
		},
		
		getInvitationLink: function(host){
			return dojo.string.substitute("${0}/web/projects/${1}", [host, this.name.value]); //$NON-NLS-1$
		},
		
		customizeAndSendTeamInvitation: function(invitees, singleUser, showLink){
			var emailObj = {};
			emailObj.subject = dojo.string.substitute(this.messages.ProjectAreaEditor_39, [this.name.value]);
			
			var host = document.location.protocol + "//" + document.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
			var link = this.getInvitationLink(host);
			link = encodeURI(link);
			emailObj.message = dojo.string.substitute(this.messages.ProjectAreaEditor_38, [this.name.value, link]);
			
			if (invitees.length == 1) {
				emailObj.description = dojo.string.substitute(this.messages.ProjectAreaEditor_36, [singleUser.name]);
				emailObj.singleUserObj = singleUser;
				emailObj.properties = this.createInvitationPropertiesString(singleUser, host); //$NON-NLS-1$
			} else {
				emailObj.description = this.messages.ProjectAreaEditor_37;
			}
			
			var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
			var invitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog(emailObj, workbenchNode);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_40,
				contentNode: invitationDialog.domNode,
				width: dojo.isIE ? "48em" : "46em", //$NON-NLS-1$ //$NON-NLS-2$
				destroyContents: true,
				execute: function(dialogObj){
					var params = {
						subject: dialogObj.getEmailSubject(),
						message: dialogObj.getEmailBody(),
						cc: dialogObj.getCopySelf() ? getAuthenticatedContributor().emailAddress : ProcessConstants.EMPTY
					};
					
					params.jsonInvitees = dojo.toJson(invitees);
					this.targetObj.customTeamInvitationParams(params);
					var srh = new ServiceResponseHandler(this.targetObj, "handleInvitationResponse", "handleInvitationError"); //$NON-NLS-1$ //$NON-NLS-2$
					this.targetObj.showLink = showLink;
					if (invitees.length == 1) {
						this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_44;
					} else {
						this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_43;
					}
					ProcessClient.generateTeamInvitations(params, srh);
					this.targetObj.displayPendingMessage(this.targetObj.messages.ProjectAreaEditor_41);
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.invitationDialogObj = invitationDialog;
			invitationDialog.startup();
			invitationDialog.emailSubject.focus();
			this.connectHandles.push(dojo.connect(invitationDialog.cancelButton, ON_CLICK, dialogWidget, function(e){ //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(invitationDialog.finishButton, ON_CLICK, dialogWidget, function(e){ //$NON-NLS-1$
				this.execute(this.invitationDialogObj);
				this.close();
			}));
		},
		
		customTeamInvitationParams: function(params){
			params.projectAreaUuid = this.projectAreaItemId;
		},
		
		chooseTeamInvitees: function(newMemberIds){
			var newMemberArray = [];
			dojo.forEach(newMemberIds, function(itemId){
				dojo.forEach(this.allMembers, function(member){
					if (member.itemId === itemId) {
						newMemberArray.push(member);
					}
				});
			}, this);
			
			var mixinObj = {};
			mixinObj.newMembers = newMemberArray;
			
			var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
			var self = this;
			var teamInvitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog(mixinObj, workbenchNode);
			var dialogWidget = new jazz.ui.Dialog({
				primaryTitle: this.messages.ProjectAreaEditor_42,
				contentNode: teamInvitationDialog.domNode,
				width: dojo.isIE ? "38em" : "36em", //$NON-NLS-1$ //$NON-NLS-2$
				destroyContents: true,
				execute: function(){
					var invitees = this.teamInvitationDialogObj.getChosenMembers();
					if (invitees.length > 0) {
						self.customizeAndSendTeamInvitation(invitees, this.teamInvitationDialogObj.singleUser, true);
					}
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.teamInvitationDialogObj = teamInvitationDialog;
			teamInvitationDialog.startup();
			teamInvitationDialog.okButton.focus();
			this.connectHandles.push(dojo.connect(teamInvitationDialog.cancelButton, ON_CLICK, dialogWidget, function(e){
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(teamInvitationDialog.okButton, ON_CLICK, dialogWidget, function(e){
				this.execute();
				this.close();
			}));
		},
		
		handleInvitationResponse: function(response){
			this.displaySuccessMessage(this.messageToDisplay, this.showLink);
		},
		
		handleInvitationError: function(error){
			this.handleServerResponseError(error, this.messages.ProjectAreaEditor_45, [ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION]);
		},
		
		adminRemoveHandler: function(e){
			dojo.stopEvent(e);
			if (this.pendingAdminChanges.remove == null) {
				this.pendingAdminChanges.remove = [];
			}
			var rowNode = e.target;
			while (rowNode.tagName !== "TR") { //$NON-NLS-1$
				rowNode = rowNode.parentNode;
			}
			var selectedUser = rowNode.userObj;
			var itemId = selectedUser.itemId;
			
			this.pendingAdminChanges.remove.push(itemId);
			for (var j = 0; j < this.allAdmins.length; j++) {
				if (itemId === this.allAdmins[j].itemId) {
					this.allAdmins.splice(j, 1);
					break;
				}
			}
			if (this.pendingAdminChanges.add != null) {
				for (j = 0; j < this.pendingAdminChanges.remove.length; j++) {
					if (this.pendingAdminChanges.add[j] == itemId) {
						this.pendingAdminChanges.add.splice(j, 1);
						break;
					}
				}
			}
			this.setDirty(true);
			this.populateAdmins(this.allAdmins);
		},
		
		addNewMembers: function(newMembers){
			if (newMembers != null) {
				if (newMembers.length > 0) {
					this.setDirty(true);
					if (this.pendingMemberChanges.add == null) {
						this.pendingMemberChanges.add = [];
					}
				}
				
				var defaultRole = this.getDefaultRole();
				for (var i = 0; i < newMembers.length; i++) {
					var member = newMembers[i];
					member.itemId = member.itemId;
					member.processRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					member.savedProcessRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					this.allMembers.push(member);
					this.pendingMemberChanges.add.push(member.itemId);
					if (this.pendingMemberChanges.remove != null) {
						for (var j = 0; j < this.pendingMemberChanges.remove.length; j++) {
							if (this.pendingMemberChanges.remove[j] == member.itemId) {
								this.pendingMemberChanges.remove.splice(j, 1);
								break;
							}
						}
					}
				}
			}
			this.populateMembers(this.allMembers);
		},
		
		getDefaultRole: function(){
			if (this.allProcessRoles) {
				for (var i = 0; i < this.allProcessRoles.length; i++) {
					if (this.allProcessRoles[i].id === ProcessConstants.DEFAULT_ROLE_ID) { //$NON-NLS-1$
						return this.allProcessRoles[i];
					}
				}
			}
			// new process area case...no roles yet
			return {
				id: ProcessConstants.DEFAULT_ROLE_ID
			};
		},
		
		addNewAdmins: function(newAdmins){
			if (newAdmins != null) {
				if (newAdmins.length > 0) {
					this.setDirty(true);
					if (this.pendingAdminChanges.add == null) {
						this.pendingAdminChanges.add = [];
					}
				}
				var defaultRole = this.getDefaultRole();
				for (var i = 0; i < newAdmins.length; i++) {
					var admin = newAdmins[i];
					admin.itemId = admin.itemId;
					admin.processRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}];
					admin.savedProcessRoles = [{
						id: ProcessConstants.DEFAULT_ROLE_ID,
						label: defaultRole.label,
						description: defaultRole.description
					}]; //$NON-NLS-1$
					this.allAdmins.push(admin);
					this.pendingAdminChanges.add.push(admin.itemId);
					if (this.pendingAdminChanges.remove != null) {
						for (var j = 0; j < this.pendingAdminChanges.remove.length; j++) {
							if (this.pendingAdminChanges.remove[j] == admin.itemId) {
								this.pendingAdminChanges.remove.splice(j, 1);
								break;
							}
						}
					}
				}
			}
			this.populateAdmins(this.allAdmins);
		},
		
		handleChange: function(e){
			this.handleCustomChange(e);
			
			if (e.target.value != e.target.savedValue) {
				e.target.changePending = true;
				this.setDirty(true);
			} else {
				e.target.changePending = false;
				if (!this.changesPending()) {
					this.setDirty(false);
				}
			}
		},
		
		setDirty: function(isDirty){
			this.enableSaveButton(isDirty);
			if (isDirty) {
				this.modifiedFlag.style.display = ProcessConstants.INLINE;
				if (this._canSave()) {
					this._clearMessage();
				}
			} else {
				this.modifiedFlag.style.display = ProcessConstants.NONE;
			}
		},
		
		enableSaveButton: function(isDirty){
			if (isDirty && this.name.value && (!this.isNew || this.processSelector.selectedIndex > -1) && this._canSave()) {
				this.saveButton.disabled = false;
			} else {
				this.saveButton.disabled = true;
			}
			
		},
		
		_canSave: function(){
			// TODO need generic ability to call on each tab
			if (this.rolesEditor) {
				return this.rolesEditor.canSave();
			}
			
			return true;
		},
		
		changesPending: function(){
			for (var i = 0; i < this.inputFields.length; i++) {
				if (this.inputFields[i].changePending) {
					return true;
				}
			}
			for (i in this.pendingMemberChanges) {
				return true;
			}
			for (i in this.pendingAdminChanges) {
				return true;
			}
			
			if (!this.isNew && this._saveParticipants) {
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					if (iter.get().value.changesPending()) {
						return true;
					}
				}
			}
			
			return this.customChangesPending();
		},
		
		customChangesPending: function(){
			// Derived can override and add custom changes pending here
		
		},
		
		handleSave: function(e){
			dojo.stopEvent(e);
			this.deferredSaveCount = this.getDeferredSaveCount();
			delete this.errObj;
			this.saveButton.disabled = true;
			var saveObj = {
				itemId: this.projectAreaItemId
			};
			if (!this.isNew) {
				saveObj.stateId = this.stateId;
			}
			for (var i = 0; i < this.inputFields.length; i++) {
				if (this.inputFields[i].changePending) {
					saveObj[this.inputFields[i].name] = this.inputFields[i].value;
				}
			}
			saveObj.jsonMembers = dojo.toJson(this.pendingMemberChanges);
			saveObj.jsonAdmins = dojo.toJson(this.pendingAdminChanges);
			if (this.isNew) {
				if (this.processSelector != null) {
					saveObj.processUuid = this.processSelector.value;
					saveObj.processLocale = this.processSelector.options[this.processSelector.selectedIndex].locale;
				}
			}
			if (saveObj.processLocale === null || saveObj.processLocale === undefined) {
				saveObj.processLocale = this.processLocale ? this.processLocale : ProcessConstants.EMPTY;
			}
			
			this.generateChangeParameters(saveObj);
			this.generateRoleChanges(saveObj);
			this.customSave(saveObj);
			
			var msg = this.validateRequired(saveObj);
			if (msg != null && msg != ProcessConstants.EMPTY) {
				this.displayErrorMessage(msg);
			} else {
				var srh = new ServiceResponseHandler(this, "handleSaveResponse", "handleSaveError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.postProjectArea(saveObj, srh);
				if (this.isNew) {
					this.displayPendingMessage(this.messages.ProjectAreaEditor_24);
				} else {
					this.displayPendingMessage(this.messages.ProjectAreaEditor_25);
				}
			}
		},
		
		customSave: function(saveObj){
			// Derived can override and add custom save here
		
		},
		
		generateRoleChanges: function(saveObj){
			if (this.rolesEditor && this.rolesEditor.changesPending()) {
				var jsonRoles = {};
				jsonRoles.add = this.definedRoles;
				jsonRoles.remove = this.originalDefinedRoles;
			}
			if (jsonRoles) {
				saveObj.jsonRoles = dojo.toJson(jsonRoles);
			}
		},
		
		validateRequired: function(saveData){
			if (saveData.name == ProcessConstants.EMPTY || (this.isNew && saveData.name == null)) {
				this.togglePrimaryField(ProcessConstants.EditorMode.EDIT);
				return this.messages.ProjectAreaEditor_26;
			}
			if (this.isNew && (saveData.processUuid == null || saveData.processUuid == ProcessConstants.EMPTY)) {
				if (this.processList.options.length == 0) {
					return this.messages.ProjectAreaEditor_27;
				} else {
					this.processList.focus();
					return this.messages.ProjectAreaEditor_28;
				}
			}
			
			// TODO need generic mechanism that is called on each tab
			if (this.rolesEditor) {
				return this.rolesEditor.validateRequired();
			}
		},
		
		generateChangeParameters: function(saveObj){
			if (!this.isNew) {
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					iter.get().value.aboutToBeSaved(saveObj);
				}
			}
		},
		
		addSaveParticipant: function(participant, participantId){
			if (!this._saveParticipants.contains(participantId)) {
				this._saveParticipants.add(participantId, participant);
				return true;
			}
			var message = dojo.string.substitute(this.messages.AbstractProjectAreaEditor_DuplicateSaveParticipant, [participantId]);
			this.displayErrorMessage(message);
			throw new Error(message);
		},
		
		removeSaveParticipant: function(participantId){
			if (this._saveParticipants.contains(participantId)) {
				this._saveParticipants.remove(participantId);
				return true;
			}
			return false;
		},
		
		handleSaveResponse: function(response){
			if (this.pendingMemberChanges.add != null && this.pendingMemberChanges.add.length > 0) {
				var currentUser = getAuthenticatedContributor();
				var newMemberIds = dojo.filter(this.pendingMemberChanges.add, function(memberId){
					return memberId != currentUser.itemId;
				});
				if (newMemberIds.length > 0) {
					dojo.cookie(TEAM_INVITATION_COOKIE_NAME, dojo.toJson(newMemberIds));
				}
			}
			
			if (this.isNew && response) {
				dojo.publish(ProcessConstants.ProjectSelectorContext.ADD, [this.name.value]);
				dojo.cookie(MSG_COOKIE_NAME, this.messages.ProjectAreaEditor_29);
				this._unregisterHandlers();
				document.location.href = "#action=" + PROJECT_AREA_EDITOR + "&itemId=" + response; //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				if (this.name.changePending && !this._isArchived) {
					dojo.publish(ProcessConstants.ProjectSelectorContext.DELETE, [this.name.savedValue]);
					dojo.publish(ProcessConstants.ProjectSelectorContext.ADD, [this.name.value]);
				}
				this.handleServerResponseSuccess(response);
				var iter = this._saveParticipants.getIterator();
				while (!iter.atEnd()) {
					iter.get().value.saved(response);
				}
			}
		},
		
		handleSaveError: function(error){
			this.saveButton.disabled = false;
			this.handleServerResponseError(error, this.getSaveErrorMessage(), [ProcessConstants.STALE_DATA_EXCEPTION, ProcessConstants.PERMISSION_DENIED_EXCEPTION, ProcessConstants.TEAM_OPERATION_CANCELED_EXCEPTION]);
		},
		
		getSaveErrorMessage: function(err){
			return this.messages.ProjectAreaEditor_31;
		},
		
		onRefresh: function(e){
			dojo.stopEvent(e);
			if (this.changesPending() && !confirm(this.messages.ProjectAreaEditor_32)) {
				return;
			}
			this.refresh(true);
		},
		
		displaySuccessMessage: function(msg, showManagerLink){
			this.displayMessage(msg, "successMsg"); //$NON-NLS-1$
			if (showManagerLink) {
				this.messageBox.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
				var link = document.createElement("a"); //$NON-NLS-1$
				link.href = "#action=" + MANAGER; //$NON-NLS-1$
				link.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_33));
				this.messageBox.appendChild(link);
			}
		},
		
		displayPendingMessage: function(msg){
			this.displayMessage(msg, "pendingMsg"); //$NON-NLS-1$
		},
		
		displayErrorMessage: function(msg){
			this.displayMessage(msg, "errorMsg"); //$NON-NLS-1$
		},
		
		displayWarningMessage: function(msg){
			this.displayMessage(msg, "warningMsg"); //$NON-NLS-1$
		},
		
		displayMessage: function(msg, cssClass){
			dojox.data.dom.removeChildren(this.messageBox);
			dojox.data.dom.removeChildren(this.longMessageBox);
			this.longMessageBox.className = ProcessConstants.EMPTY;
			this.messageBox.className = "message shortMsg " + cssClass; //$NON-NLS-1$
			this.messageBox.appendChild(document.createTextNode(msg));
		},
		
		displayLongSuccessMessage: function(msg){
			if (dojo.isString(msg)) {
				msg = document.createTextNode(msg);
			}
			this.displayLongMessage(msg, "successMsg"); //$NON-NLS-1$
		},
		
		displayLongWarningMessage: function(msg){
			if (dojo.isString(msg)) {
				msg = document.createTextNode(msg);
			}
			this.displayLongMessage(msg, "warningMsg"); //$NON-NLS-1$
		},
		
		displayLongErrorMessage: function(msg){
			if (dojo.isString(msg)) {
				msg = document.createTextNode(msg);
			}
			this.displayLongMessage(msg, "errorMsg"); //$NON-NLS-1$
		},
		
		displayLongMessage: function(msg, cssClass){
			dojox.data.dom.removeChildren(this.messageBox);
			this.messageBox.className = ProcessConstants.EMPTY;
			dojox.data.dom.removeChildren(this.longMessageBox);
			this.longMessageBox.className = "message longMsg " + cssClass; //$NON-NLS-1$
			this.longMessageBox.appendChild(msg);
		},
		
		_destroyActionToolbars: function(){
			for (var i = 0; i < this._actionToolbars.length; i++) {
				this._actionToolbars[i].destroyRecursive();
			}
			this._actionToolbars = [];
		},
		_destroySaveParticipants: function(){
			if (this._saveParticipants) {
				var keys = this._saveParticipants.getKeyList();
				for (var i = 0; i < keys.length; i++) {
					this._saveParticipants.remove(keys[i]);
				}
				delete this._saveParticipants;
			}
			
		},
		
		_getServerUrl: function(){
			var location = new String(document.location);
			var separator = "/"; //$NON-NLS-1$
			var path = location.split(separator); //$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + separator + separator;
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress;
		},
		uninitialize: function(){
			this._destroyActionToolbars();
			dojo.forEach(this.connectHandles, function(handle){
				dojo.disconnect(handle);
			});
			
			if (this.rolesEditor) {
				this.rolesEditor.destroyRecursive();
				delete this.rolesEditor;
				
			}
			
			if (this.permissionEditor) {
				this.permissionEditor.destroyRecursive();
				delete this.permissionEditor;
			}
			
			this._destroySaveParticipants();
			
			if (this._widgetCache) {
				for (var tabId in this._widgetCache) {
					this._widgetCache[tabId] = null;
				}
				delete this._widgetCache;
			}
			
			if (this._tabs) {
				for (tabId in this._tabs) {
					this._tabs[tabId] = null;
				}
				delete this._tabs;
			}
			
			
			this.inherited(arguments);
		},
		
		handleCustomChange: function(e){
			// Derived can override and add custom event handling here
		},
		
		getDeferredSaveCount: function(){
			// Derived can override and provide custom number here
			return 1;
		}
	});
	
})();
