﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class XAxis extends Axis {

	public static var X_AXIS_LABEL_NAME:String = "xaxis_label_mc_";
	
	public static var LABEL_FORMAT:TextFormat = XAxis._initTextFieldFormat();	
	
	
	public function XAxis() {
		super();
	}
	
	private static function _initTextFieldFormat():TextFormat {
		var textFieldFormat = new TextFormat();
		textFieldFormat.color = 0x666666;
		textFieldFormat.font = ChartArea.FONT;
		// Each character
		// W X H
		// 6 X 7 pixels
		textFieldFormat.size = 10;
		textFieldFormat.align = "left";
		
		return textFieldFormat;
	}		
	
	public function draw(parentMC:MovieClip, gridData:GridData):Void {

		this.mc = parentMC.createEmptyMovieClip("xaxis_mc", parentMC.getNextHighestDepth());		
		this.gridData = gridData;
		
		this.mc.lineStyle(Axis.LINE_THICKNESS, Axis.LINE_COLOUR);
		
		this.mc.moveTo(this.gridData.xZeroPosition, 
					   this.gridData.yZeroPosition);
		this.mc.lineTo(this.gridData.xZeroPosition + this.gridData.graphAreaWidth, 
					   this.gridData.yZeroPosition);
		
	}
	
	public function drawVDashedLine(startX:Number, startY:Number, endY:Number):Void {
		
		var dashSegmentLength:Number = Axis.DASH_LENGTH + Axis.DASH_SPACE_LENGTH;
		var lineLength:Number = startY - endY;
		var count:Number = Math.floor(lineLength / dashSegmentLength);
		var positionY:Number = startY;		
		var step:Number = 0;
		
		this.mc.moveTo(startX, positionY);

		this.mc.lineStyle(Axis.LINE_THICKNESS, Axis.LINE_COLOUR);
		
		for (step = 0; step < count; step++) {
			// Dash
			this.mc.lineTo(startX, positionY - Axis.DASH_LENGTH);
			// Space
			positionY = positionY - Axis.DASH_LENGTH - Axis.DASH_SPACE_LENGTH;
			this.mc.moveTo(startX, positionY);
		}
		
		var tail:Number = positionY - endY;

		if (tail > 0) {
			var lastPositionY:Number;
			if (tail < Axis.DASH_LENGTH) {
				// Draw a partial dash
				// Exactly aligned with Y-Axis
				lastPositionY = endY;
			} else {
				// Draw a full dash
				// Not aligned with Y-Axis (slightly shorter)
				lastPositionY = positionY - Axis.DASH_LENGTH;
			}
			this.mc.lineTo(startX, lastPositionY);
		}
	}		
	
	public function destroy():Void {
		super.destroy();
	}		
	
}