/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.users.dialogs.AssingmentEditDialog"); //$NON-NLS-1$

dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.TimeTextBox"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var bind= dojo.string.substitute;

dojo.declare("com.ibm.team.apt.web.ui.internal.users.dialogs.AssingmentEditDialog", null, { //$NON-NLS-1$
	
	constructor: function(params){
		var widgetParams = { primaryTitle: MSGS.USER_EDITOR_ASSIGNMENT_EDIT_DIALOG_TITLE, width: "25em" }; //$NON-NLS-1$

		var onOk= dojo.hitch(this, function(attributes) {
			this.floatingPane.close();
			params.onOk({});
		});
		
		var onCancel= dojo.hitch(this, function(attributes) {
			this.floatingPane.close();
			params.onCancel({});
		}); 
		
		this.contentWidget= new com.ibm.team.apt.web.ui.internal.users.dialogs.AssignmentEditDialogContent({
			onOk: onOk,  
			onCancel: onCancel,
			assignment: params.assignment
		});
		widgetParams.contentNode = this.contentWidget.domNode;
		this.floatingPane = new jazz.ui.Dialog(widgetParams); 
		this.contentWidget.init();
	}
	
});

dojo.declare("com.ibm.team.apt.web.ui.internal.users.dialogs.AssignmentEditDialogContent", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {
					
	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/dialogs/templates/AssignmentEditDialogContent.html"), //$NON-NLS-1$ //$NON-NLS-2$
					
	__okOk: null,
	__onCancel: null,
	__assignment: null,
	
	__messages: MSGS,
	
	constructor: function(params){
		this.__assignment= params.assignment;	
		this.__onOk= params.onOk;
		this.__onCancel= params.onCancel;
	},
	
	postCreate: function() {
		this.connect(this._okCmd, "onclick", dojo.hitch(this, function() { //$NON-NLS-1$
			this.__assignment.percentage= parseInt(this._input.value, 10);
			
			this.__onOk();
		}));
		this.connect(this._cancelCmd, "onclick", this.__onCancel); //$NON-NLS-1$
		
		this._input.value= this.__assignment.percentage;
		this.connect(this._input, "onkeypress", dojo.hitch(this, function(e) { //$NON-NLS-1$
			this.__updateState(this._input.value + e.keyChar);
		}));
		
		this._okCmd.disabled= true;
	},
	
	init: function() {
	},
	
	__updateState: function(inputValue) {
		this._okCmd.disabled= true;
		
		try {
			var value= parseInt(inputValue, 10);
			if (value != inputValue)
				return
			
			if (value < 0 || value > 100)
				return;
			
			this._okCmd.disabled= false;
		} catch (e) {
			return;
		}
	},
	
	__sentinel: null
});

})();
