/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.PromoteAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/decrease_indent.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.PromoteAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction], {
	
	_viewModel: null,
	_movePolicy: null,
	
	constructor: function(viewModel, itemMovePolicy, errorReporter) {
		this._viewModel= viewModel;
		this._movePolicy= itemMovePolicy;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "move.promote"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_MOVE_ELEMENT_PROMOTE;
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	canHandle: function(targetEntry, selection) {
		if (arguments.length == 0)
			return this._canHandle();
		
		var entry;
		if (targetEntry) {
			entry= targetEntry;
		} else {
			if (selection.length != 1)
				return false;
			
			entry= selection[0];
		}

		return this._movePolicy.canMove(entry, entry, com.ibm.team.apt.ui.Move.Promote);
	},
	
	_doHandle: function(targetEntry, selection) {
		var entry;
		if (targetEntry) {
			entry= targetEntry;
		} else {	
			entry= selection[0];
		}
		
		return this._movePolicy.move(targetEntry, targetEntry, com.ibm.team.apt.ui.Move.Promote);
	},

	__sentinel: null // terminates this class definition
});

})();
