/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.WorkItemSaveManager"); //$NON-NLS-1$

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;
var WorkItemSaveManager				= com.ibm.team.apt.web.client.internal.WorkItemSaveManager;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {
	
	_viewModel: null,
	_errorReporter: null,
	
	constructor: function(viewModel, itemMovePolicy, errorReporter) {
		this._viewModel= viewModel;
		this._errorReporter= errorReporter;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	handle: function(target, selection) {
		if (arguments.length == 1) {
			this._handle();
			return;
		}
		
		WorkItemSaveManager.compoundSave(function() {
			this._doHandle(target, selection);
		}, this._viewModel, this._errorReporter, this);
	},
	
	// ---- spi ------------------------------------------------------------------------------------------------------------
	
	_doHandle: function(target, selection) {
		Assert.isTrue(false, "subclass must implement SaveRunnerExecuteAction#_doHandle()"); //$NON-NLS-1$
	},
	
	_canHandle: function() {
		var selection= this._viewModel.getSelectedEntries();
		if (selection.length != 1)
			return false;
		
		return this.canHandle(selection[0], selection);
	},
	
	_handle: function() {
		var selection= this._viewModel.getSelectedEntries();
		if (selection.length != 1)
			return;
		
		this.handle(selection[0], selection);
	},

	__sentinel: null // terminates this class definition
});

})();
