/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.page.PropertyManager");

dojo.require("com.ibm.rational.cm.web._base");

(function(){

var cq = com.ibm.rational.cm.web;
var BASE_URL = "cqproperties.cq";
var _propInfo;

dojo.declare(
	"com.ibm.rational.cm.web.ui.page.PropertyManager",
	null,
{
	constructor: function(){
		_propInfo = {};
	},
	
	getProperties: function(obj){
		var resourceId = obj.resourceId;
		if(!resourceId && resourceId.length === 0){ return; }
		if(_propInfo[resourceId]){
			if(obj.onBegin){
				obj.onBegin();
			}
			obj.onLoad(_propInfo[resourceId]);
			if(obj.onHandle){
				obj.onHandle();
			}
		}else{
			cq.xhrGet({
				url: BASE_URL,
				content: {
					action: "GetProperty",
					resourceId: resourceId
				},
				onBegin: obj.onBegin,
				load: function(response, ioArgs){
					if(response && response.STATUS == "true"){
						_propInfo[resourceId] = response.data[0];
						obj.onLoad(_propInfo[resourceId]);
					}
				},
				error: obj.onError,
				handle: obj.onHandle,
				handleError: true,
				preventCache: true
			});
		}
	}
});

})();

com.ibm.rational.cm.web.ui.page.propManager = new com.ibm.rational.cm.web.ui.page.PropertyManager();