/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.PlanElementAccessor"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanningAttributeIdentifier"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.apt.client.PlanElementAccessor", null, { //$NON-NLS-1$

	__complexityAttributeId: null,
	
	constructor: function(complexityAttributeId) {
		this.__complexityAttributeId= complexityAttributeId;
	},

	isPlanItem: function(entry) {
		return entry instanceof com.ibm.team.apt.client.PlanItem;
	},
	
	getChildren: function(entry) {
		return entry.getChildren();
	},

	getComplexity: function(entry) {
		var value= this.__complexityAttributeId != null ? entry.getAttributeValue(this.__complexityAttributeId) : null;
		return this.__workItemEstimatorGetComplexity(value);
	},
	
	__workItemEstimatorGetComplexity: function(value){
		if(value === undefined){
			return 0;
		}
		
		if(value === null){
			return 0;
		}
			
		var number= 0;			
		if(value instanceof Object){
			if(value instanceof Number){
				return value;
			}
			if(value instanceof com.ibm.team.workitem.common.Literal){
				number= Number(value.itemId);
				if(!isNaN(number)){
					return number;
				}
				number= Number(value.label);
				if(!isNaN(number)){
					return number;
				}
			}
		}
		
		number= Number(value);
		if(isNaN(number)){
			return 0;
		} else {
			return number;
		}
	},
	
	getDuration: function(entry) {
		return entry.getDuration();
	},

	isAuxiliaryPlanItem: function(entry) {
		return entry.isAuxiliaryPlanItem();
	},

	isPrimaryElement: function(entry) {
		return true;
	},	
	
	isResolved: function(entry) {
		return entry.isResolved();
	},

	isTopLevelPlanItem: function(entry) {
		return entry.isTopLevelPlanItem();
	},
	
	__sentinel: null // terminates this class definition
});

})();
