/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.PlanModel"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanElement"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.OutOfOfficeItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanDeltaBuilder"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanElementAttributeDelta"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanElementDelta"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.ItemSequenceManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.Instant"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttributeType"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttributeValueSet"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanAttributeRegistry"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.ReflectiveAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttributeIdentifier"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.plancheck.PlanCheckEngine"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.internal.attributes.PlanItemWorkItemAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.UnresolvedWorkItemAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.SequenceValueAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.StateAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.SequenceAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.attributes.WorkflowActionAttribute"); //$NON-NLS-1$

// FIXME move ReferencedItemStore to the client namespace
dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.cache.internal.Cache"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var PlanningAttributeIdentifier		= com.ibm.team.apt.client.PlanningAttributeIdentifier;
var PlanningAttributeValueSet		= com.ibm.team.apt.client.PlanningAttributeValueSet;
var PlanningAttributeType			= com.ibm.team.apt.client.PlanningAttributeType;
var ReflectiveAttribute				= com.ibm.team.apt.client.internal.attributes.ReflectiveAttribute;
var PlanElement						= com.ibm.team.apt.client.PlanElement;
var PlanItem						= com.ibm.team.apt.client.PlanItem;
var OutOfOfficeItem					= com.ibm.team.apt.client.OutOfOfficeItem;
var PlanElementAttributeDelta		= com.ibm.team.apt.client.PlanElementAttributeDelta;
var PlanElementDelta				= com.ibm.team.apt.client.PlanElementDelta;
var ReferencedItemStore				= com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore;
var PlanDeltaBuilder				= com.ibm.team.apt.client.PlanDeltaBuilder;
var ItemSequenceManager				= com.ibm.team.apt.client.internal.ItemSequenceManager;
var Instant							= com.ibm.team.apt.client.internal.Instant;
var WorkingCopyRegistry				= com.ibm.team.workitem.web.cache.internal.Cache;
var PlanAttributeRegistry			= com.ibm.team.apt.client.PlanAttributeRegistry;
var PlanItemWorkItemAttribute		= com.ibm.team.apt.client.internal.attributes.PlanItemWorkItemAttribute;
var UnresolvedWorkItemAttribute		= com.ibm.team.apt.client.internal.attributes.UnresolvedWorkItemAttribute;
var SequenceValueAttribute			= com.ibm.team.apt.client.internal.attributes.SequenceValueAttribute;
var StateAttribute					= com.ibm.team.apt.client.internal.attributes.StateAttribute;
var SequenceAttribute				= com.ibm.team.apt.client.internal.attributes.SequenceAttribute;
var WorkflowActionAttribute			= com.ibm.team.apt.client.internal.attributes.WorkflowActionAttribute;
var PlanCheckEngine					= com.ibm.team.apt.client.internal.plancheck.PlanCheckEngine;
var EstimateConfig					= com.ibm.team.apt.web.client.util.EstimateConfig;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var PlanModel= dojo.declare("com.ibm.team.apt.client.PlanModel", PlanElement, { //$NON-NLS-1$

	__planId: null,
	__planProgress: null,
	__defaultPlanModeId: null,
	__planModes: null,
	__iterationHierarchy: null,
	__rootTeamMemberArea: null,
	__teamMemberAreas: null,
	__category2teamArea: null,
	__teamArea2category: null,	
	__referencedItems: null,
	
	__referenceTime: null,
	__sequenceManagers: null,
	
	__listeners: null,
	
	__planConnectCounter: 0,
	__deltaBuilderCounter: null,
	__deltaBuilder: null,
	
	__workItemAttributes: null,
	__planItemAttriutes: null,
	__attributeRegistry: null,
	__attributeDependencies: null,
	
	__planItemMap: null,
	__itemTypes: null,
	__topLevelWorkItemTypes: null,
	
	__planCheckEngine: null,
	__checkReport: null,

	__unassignedCategory: null,

	constructor: function(planDTO, planId) {
		this.__planItemMap= {};
		this.__referenceTime= new Instant(new Date());
		this.__deltaBuilderCounter= 0;
		this.__listeners= [];
		this.__planId= planId;
		this.__planProgress= planDTO.planProgress;
		this.__planModes= planDTO.planModes;
		this.__defaultPlanModeId= planDTO.defaultPlanMode;
		this.__iterationHierarchy= planDTO.getIterationHierarchy();
		this.__referencedItems= planDTO._referencedItemStore; 
		this.__iterations= dojo.map(planDTO.iterations, function(iterationId){ return this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES.ITERATION, iterationId); }, this);
		this.__categories= dojo.map(planDTO.categories, function(categoryId){ return this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES.CATEGORY, categoryId); }, this);
		this.__itemTypes= dojo.map(planDTO.workItemTypes, function(typeId){ return this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES.WITYPE, typeId); }, this);
		this.__topLevelWorkItemTypes= planDTO.topLevelWorkItemTypes;
		this.__rootTeamMemberArea= planDTO.getTeamArea();
		this.__attributeRegistry= new PlanAttributeRegistry();
		this.__attributeDependencies= {};

		this.__teamMembers= [];
		this.__absences= [];
		dojo.forEach(planDTO.workEnvironments, function(workEnvironment) {
			var teamMember= workEnvironment.getContributor();
			this.__teamMembers.push(teamMember);
			dojo.forEach(workEnvironment.absences, function(absenceId) {
				var absence= this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES.CONTRIBUTORABSENCE, absenceId);
				this.__absences.push(new OutOfOfficeItem(this, absence, teamMember));
			}, this);
		}, this);

		// creating the Attributes requires the __teamMembers to be available
		this.__createAttributes(planDTO.workItemAttributes, planDTO.planElementAttributes);
		
		// creating the PlanItems requires the Attributes to be available
		dojo.forEach(planDTO.workItems, function(workItemId) {
			this.__processPlanItem(this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES.WORKITEM, workItemId));
		}, this);		

		// creating the ItemSequenceManagers requires the PlanItems to be available
		this.__sequenceManagers= {};
		dojo.forEach(planDTO.workEnvironments, function(workEnvironment) {
			var teamMember= workEnvironment.getContributor();
			var manager= new ItemSequenceManager(this, teamMember);
			manager.initialize(workEnvironment);
			this.__sequenceManagers[teamMember.itemId]= manager;
		}, this);

		this.__planCheckEngine= new PlanCheckEngine(this, dojo.hitch(this, function(newReport) {
			this.compoundChange(function(deltaBuilder) {
				deltaBuilder.planCheckChanged(this.__checkReport, newReport);
				newReport.removeEmptyReports();
				this.__checkReport= newReport;
			}, this);
		}));
		
		dojo.forEach(planDTO.planChecks, function(planCheckDescriptor) {
			if (planCheckDescriptor.implementation != "com.ibm.team.apt.internal.client.plancheck.RequiredAttributeCheck") { //$NON-NLS-1$
				var ctor= planCheckDescriptor.getConstructor();
				var planCheck= new ctor(planCheckDescriptor, this);
				planCheck.initialize(this);
				this.__planCheckEngine.addCheck(planCheck);
			}
		}, this);

		this.__teamMemberAreas= [];
		this.__category2teamArea= {};
		this.__teamArea2category= {};
		this.__unassignedCategory= this.findAttribute(com.ibm.team.apt.client.PlanItem.CATEGORY).getValueSet().nullValue;

		function processTeamMemberAreas(area) {
			this.__teamMemberAreas.push(area);
			var primaryCategory= null;
			dojo.forEach(area.getCategories(), function(category) {
				this.__category2teamArea[category.itemId]= area;
				if (primaryCategory == null || primaryCategory.itemId == this.__unassignedCategory.itemId) {
					primaryCategory= category;
				} else {
					if (category.compareTo(primaryCategory) < 0 && category.itemId != this.__unassignedCategory.itemId) {
						primaryCategory= category;
					}
				}
			}, this);
			if (primaryCategory != null) {
				this.__teamArea2category[area.itemId]= primaryCategory;
			}
			dojo.forEach(area.getChildren(), function(child) {
				processTeamMemberAreas.call(this, child);
			}, this);
		};
		
		processTeamMemberAreas.call(this, this.getRootTeamMemberArea());

		this.__planConnectCounter++;
		
		this.__planCheckEngine.runFullCheck();
	},
		
	// ---- api ------------------------------------------------------------------------------------------------------------

	dispose: function() {
		this.__planCheckEngine.cancel();
		this.__planConnectCounter--;
	},
	
	getPlanModel: function() {
		return this;
	},
	
	getPlanId: function() {
		return this.__planId;
	},
	
	getPlanProgress: function(){
		return this.__planProgress;
	},
	
	getComplexityAttribute: function(){
		if(!this.getPlanProgress().complexityAttribute)
			return null;
		return new PlanningAttributeIdentifier(this.getPlanProgress().complexityAttribute.attributeId);
	},
	
	useComplexity: function() {
		return this.__planProgress.useComplexity;
	},
	
	getEstimateMode: function() {
		return EstimateConfig.estimateMode;
	},
	
	getTopLevelWorkItemTypes: function() {
		return this.__topLevelWorkItemTypes;
	},
	
	getCheckReport: function() {
		return this.__checkReport;
	},
	
	getPlanChecks: function() {
		var result= [];
		dojo.forEach(this.__planCheckEngine.getChecks(), function(planCheck) {
			result.push(planCheck.getCheckDescription());
		}, this);
		return result;
	},
	
	equals: function(other) {
		return this === other;
	},

	getPlanItem: function(itemId, typeHint) {
		return this.__planItemMap[itemId];
	},

	getItem: function(itemId, typeHint) {
		if (arguments.length >= 2) {
			return this.__referencedItems.getItem(typeHint, itemId);
		}
		
		if (this.__planItemMap[itemId])
			return this.__planItemMap[itemId];

		for (var type in ReferencedItemStore.ITEM_TYPES) {
			var item= this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES[type], itemId);
			if (item)
				return item;
		}

		return null;
	},
	
	getProblemDefinition: function(problemId) {
		return this.__planCheckEngine.getProblemDefinition(problemId);
	},
	
	findAttribute: function(attributeIdentifier) {
		return this.__attributeRegistry.getAttribute(attributeIdentifier);
	},

	getAllAttributes: function() {
		return this.__attributeRegistry.getAllAttributes();
	},
	
	getReferenceTime: function() {
		return this.__referenceTime;
	},

	getStartDate: function() {
		return this.__iterationHierarchy.getElement().startDate;
	},

	getEndDate: function() {
		return this.__iterationHierarchy.getElement().endDate;
	},
	
	getItemSequenceManager: function(owner) {
		return owner != null ? this.__sequenceManagers[owner.itemId] : null;
	},

	getWorkflowInfo: function(workflowId) {
		return this.getItem(workflowId);
	},
	
	getCreatableWorkItemTypes: function() {
		if (this.__isIterationPlan() || this.__isTeamPlan())
			return this.getWorkItemTypes();
		return dojo.filter(this.getWorkItemTypes(), function(itemType) { return itemType.topLevel });
	},
	
	getWorkItemTypes: function() {
		return this.__itemTypes;
	},
	
	getDefaultWorkItemType: function() {
		var isIterationPlan= !this.useComplexity();
		var types= dojo.filter(this.__itemTypes, function(itemType) { return itemType.topLevel != isIterationPlan; });
		if (types.length == 0) {
			types= this.__itemTypes;
		}
		
		if (types.length == 0) {
			return null;
		}
		
		if (isIterationPlan) {
			for ( var i= 0; i < types.length; i++) {
				if (types[i].itemId == "task") { //$NON-NLS-1$
					return types[i];
				}
			}
		}
		return types[0];
	},

	getTeamMembers: function() {
		return this.__teamMembers;
	},

	getIterations: function() {
		return this.__iterations;
	},
	
	getIterationHierarchy: function(){
		return this.__iterationHierarchy;
	},
	
	getPlanCategories: function() {
		return this.__categories;
	},
	
	getRootCategory: function() {
		for ( var i = 0; i < this.__categories.length; i++) {
			var category= this.__categories[i];
			if (category.itemId !== this.__unassignedCategory.itemId) {
				while (category.getParent() != null) {
					category= category.getParent();
				}
				return category;
			}
		}
		
		return null;
	},
	
	getRootTeamMemberArea: function() {
		return this.__rootTeamMemberArea; 
	},
	
	getTeamMemberAreas: function() {
		return this.__teamMemberAreas;
	},
		
	getTeamMemberArea: function(category) {
		if (!category)
			return null;
		
		return this.__category2teamArea[category.itemId];
	},
	
	getPrimaryCategoryFor: function(teamMemberArea) {
		return this.__teamArea2category[teamMemberArea.itemId];
	},

	addListener: function(listener) {
		this.__listeners.push(listener);
	},
	
	removeListener: function(listener) {
		for ( var i = 0; i < this.__listeners.length; i++) {
			if (this.__listeners[i] == listener) {
				this.__listeners.splice(i, 1);
				return;
			}
		}
	},
	
	getAllPlanItems: function() {
		var result= [];
		for (var key in this.__planItemMap) {
			result.push(this.__planItemMap[key]);
		}
		return result;
	},

	getAbsences: function(contributor) {
		if (!contributor)
			return this.__absences;
		
		return dojo.filter(this.__absences, function(absence) {
			return absence.getOwner().equals(contributor);
		});
	},

	getPlanModes: function() {
		return this.__planModes;
	},

	getDefaultPlanModeId: function() {
		return this.__defaultPlanModeId;
	},
	
	compoundChange: function(code, thisObj) {
		var builder= this.__connectDeltaBuilder();
		try {
			return code.call(thisObj, builder);
		} finally {
			this.__disconnectDeltaBuilder();
		}
	},

	/**
	 * Synchronize this plan model with all open work item working copies
	 */
	synchronizeWithWorkItemWorkingCopies: function() {
		this.compoundChange(function(builder) {
			for (var key in this.__planItemMap) {
				// PlanItems will check if there's a dirty working copy.
				this.__planItemMap[key].synchronizeWithWorkItemWorkingCopy();
			}
		}, this);
	},
	
	getParent: function() {
		return null;
	},
	
	getElementKey: function() {
		return this.__planId;
	},
	
	_matchesPlanQuery: function(planItem) {
		var workItemPlannedFor= planItem.getAttributeValue(PlanItem.TARGET);
		if (!workItemPlannedFor || !dojo.some(this.__iterations, function(planIteration) { return workItemPlannedFor.itemId == planIteration.itemId; }))
			return false;

		var workItemCategory= planItem.getAttributeValue(PlanItem.CATEGORY);
		if (!workItemCategory || !dojo.some(this.__categories, function(planCategory) { return workItemCategory.itemId == planCategory.itemId; }))
			return false;

		return true;
	},
	
	/**
	 * returns a map [workItemAttribute.internalId->planItemWorkItemAttribute]
	 * @return
	 */
	_getWorkItemAttributes: function() {
		return this.__workItemAttributes;
	},
	
	_getAuxiliaryPlanItemReasons: function(planItem) {
		var result= [];
		
		var workItemPlannedFor= planItem.getAttributeValue(PlanItem.TARGET);
		if (!workItemPlannedFor) {
			result.push(MSGS.AUX_NOT_PLANNED);
		} else if (!dojo.some(this.__iterations, function(planIteration) { return workItemPlannedFor.itemId == planIteration.itemId; })) {
			result.push(bind(MSGS.AUX_PLANNED_FOR_OTHER, [workItemPlannedFor.label]));
		}

		var workItemCategory= planItem.getAttributeValue(PlanItem.CATEGORY);
		if (!workItemCategory || !dojo.some(this.__categories, function(planCategory) { return workItemCategory.itemId == planCategory.itemId; }))
			result.push(MSGS.AUX_OTHER_CATEGORY);

		return result;
	},
	
	createNewPlanItem: function(parent, workingCopy) {
		var result= new PlanItem(this, parent, null, this.__planItemAttriutes, workingCopy);
		parent.addChild(result);
		return result;
	},
	
	// ---- spi -----------------------------------------------------------------------------------------------------------
	
	_childAdded: function(parent, child) {
			this.compoundChange(function(builder) {
				if (!builder.isInMove()) {
					this.__planItemMap[child.getUuid()]= child;
				}
				if (this.__planConnectCounter > 0) {
					builder.added(child);
				}
			}, this);
			
			if (this.__planCheckEngine) {
				this.__planCheckEngine.runCheck( [ parent, child ]);
			}
	},
	
	_childRemoved: function(parent, child) {
		this.compoundChange(function(builder) {
			if (!builder.isInMove()) {
				delete this.__planItemMap[child.getUuid()];
			}
			builder.removed(child);
		}, this);
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__isProjectPlan: function() {
		// This is a work around for now. We don't have this knowledge
		// on the client yet so we infer it from the attribute used for
		// the progress.
		return this.useComplexity() && this.__teamMemberAreas.length > 1;
	},
	
	__isTeamPlan: function() {
		// This is another inference. If we have only one team member are we assume
		// a team plan.
		return this.useComplexity() && this.__teamMemberAreas.length == 1; 
	},
	
	__isIterationPlan: function() {
		return !this.useComplexity();
	},
	
	__connectDeltaBuilder: function() {
		if (this.__deltaBuilderCounter == 0) {
			this.__deltaBuilder= new PlanDeltaBuilder(this);
		}
		this.__deltaBuilderCounter++;
		return this.__deltaBuilder;
	},

	__disconnectDeltaBuilder: function() {
		var builder= null;
		try {
			if (this.__deltaBuilderCounter == 1) {
				if (this.__planConnectCounter > 0) {
					builder= this.__deltaBuilder;
					this.__processItemSequenceManagerChanges(builder);
					this.__processCustomAttributeChanges(builder);
				}
				this.__deltaBuilder= null;
			}
		} finally {
			this.__deltaBuilderCounter--;
		}
		if (builder != null) {
			if (!builder.isEmpty())
				this.__fireEvent(builder.getEvent());
			builder.sendPostNotifications();
		}
	},

	__processItemSequenceManagerChanges: function(builder) {
		builder.getEvent().getDelta().accept(function(delta) {
			var planElement= delta.getPlanElement();
			if (planElement instanceof PlanItem) {
				var ownerDelta= delta.getAttributeDelta(PlanItem.OWNER);
				if (ownerDelta != null) {
					var oldSequenceManager= this.getItemSequenceManager(ownerDelta.getOldValue());
					if (oldSequenceManager != null) {
						oldSequenceManager._itemRemoved(planElement);
					}

					var newSequenceManager= this.getItemSequenceManager(ownerDelta.getNewValue());
					if (newSequenceManager != null) {
						newSequenceManager._itemAdded(planElement);
					}
				}

				var sequenceManager= this.getItemSequenceManager(planElement.getOwner());

				if (sequenceManager != null) {
					sequenceManager._processWorkItemChangeEvent(delta);
				}
			}
			return true;
		}, this);
	},
	
	__processCustomAttributeChanges: function(builder) {
		var maxIterations= 100;
		var hasChanges;
		do {
			hasChanges= false;
			var currentGeneration= builder.newGeneration();
			builder.getEvent().getDelta().accept(function(delta) {
				dojo.forEach(delta.getAttributeDeltas(), function(attributeDelta) {
					if (attributeDelta.getGeneration() == currentGeneration) {
						dojo.forEach(this.__attributeDependencies[attributeDelta.getAttribute().getId()], function(dependantAttribute) {
							dependantAttribute.changed(delta, builder);
							hasChanges= true;
						}, this);
					}
				}, this);
				return true;
			}, this);
		} while (hasChanges && --maxIterations > 0);

		if (hasChanges) {
			console.warn("PlanModel#__processCustomAttributeChanges: too many iterations"); //$NON-NLS-1$
		}
	},
	
	__processPlanItem: function(workItem) {
		var result= this.__planItemMap[workItem.itemId];
		if (!result) {
			var parent= workItem.parent ? this.__processPlanItem(workItem.getParent()) : this;
			result= new PlanItem(this, parent, workItem, this.__planItemAttriutes);
			parent.addChild(result);
		}
		return result;
	},

	__fireEvent: function(changeEvent) {
		for ( var j = 0; j < this.__listeners.length; j++) {
			this.__listeners[j](changeEvent);
		}
	},
	
	__createAttributes: function(workItemAttributes, planElementAttributes) {
		var i;
		var GetterKind= ReflectiveAttribute.GetterKind;
		var SetterKind= ReflectiveAttribute.SetterKind;
		
		var planElementAttributeMap= {};
		dojo.forEach(planElementAttributes, function(attributeDescriptor) {
			planElementAttributeMap[attributeDescriptor.id]= attributeDescriptor;
		});
		
		
		var toInitialize= [];
		
		var attributeMap= {};
		for (i= 0; i < workItemAttributes.length; i++) {
			var attribute= this.__referencedItems.getItem(ReferencedItemStore.ITEM_TYPES.ATTRIBUTE, workItemAttributes[i]);
			attributeMap[attribute.publicId]= { index: i, attribute: attribute };
		}
		
		this.__workItemAttributes= {};
		
		// ---- concrete PlanItem attributes to access ISchedulableItem properties on a PlanItem --------------------------- 
		// the ISchedulableItem attributes must be reflective in order to work for all types.
		// to access the respective properties on the PlanItems, we can delegate the access to these private PlanItem attributes
		this.__planItemAttriutes= {};
		this.__planItemAttriutes[PlanItem.SUMMARY.getId()]= this.__createWorkItemAttribute(PlanItem.SUMMARY, planElementAttributeMap, "com.ibm.team.workitem.attribute.summary", attributeMap); //$NON-NLS-1$
		this.__planItemAttriutes[PlanItem.OWNER.getId()]= this.__createWorkItemAttribute(PlanItem.OWNER, planElementAttributeMap, "com.ibm.team.workitem.attribute.owner", attributeMap); //$NON-NLS-1$
		this.__planItemAttriutes[PlanItem.SEQUENCE_VALUE.getId()]= this.__createWorkItemAttribute(PlanItem.SEQUENCE_VALUE, planElementAttributeMap, "com.ibm.team.workitem.attribute.sequencevalue", attributeMap, SequenceValueAttribute); //$NON-NLS-1$

		// ---- PlanElement attributes -------------------------------------------------------------------------------------

		this.__addReflectiveAttribute(PlanElement.CHILDREN, planElementAttributeMap, "children", GetterKind.HAS, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanElement.CHILDREN_COUNT, planElementAttributeMap, "childrenCount", GetterKind.GET, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanElement.PLANCHECK_REPORT, planElementAttributeMap, "checkReport", GetterKind.GET, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanElement.DIRTY, planElementAttributeMap, "dirty", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$

		// ---- PlanModel attributes ---------------------------------------------------------------------------------------
		
		this.__addReflectiveAttribute(PlanModel.RESOURCE_PLANNING, planElementAttributeMap, "resourcePlanning", GetterKind.NONE, SetterKind.NONE); //$NON-NLS-1$ 
		this.__addReflectiveAttribute(PlanModel.REFERENCE_TIME, planElementAttributeMap, "referenceTime", GetterKind.GET, SetterKind.NONE); //$NON-NLS-1$ 

		// ---- ISchedulableItem attributes -------------------------------------------------------------------------------- 
		
		this.__addReflectiveAttribute(PlanItem.SUMMARY, planElementAttributeMap, "summary", GetterKind.GET, SetterKind.SET); //$NON-NLS-1$
		var nullOwner= this.__planItemAttriutes[PlanItem.OWNER.getId()].getValueSet().nullValue;
		var ownerSet= this.getTeamMembers().slice();
		ownerSet.push(nullOwner);
		this.__addReflectiveAttribute(PlanItem.OWNER, planElementAttributeMap, "owner", GetterKind.GET, SetterKind.SET, new PlanningAttributeValueSet( //$NON-NLS-1$
			ownerSet,
			nullOwner)); 
		this.__addReflectiveAttribute(PlanItem.SEQUENCE_VALUE, planElementAttributeMap, "sequenceValue", GetterKind.GET, SetterKind.SET); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.SCHEDULED_TIME, planElementAttributeMap, "scheduledTime", GetterKind.GET, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.RESOLVED, planElementAttributeMap, "resolved", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$

		// ---- PlanItem attributes ----------------------------------------------------------------------------------------

		this.__addWorkItemAttribute(PlanItem.ID, planElementAttributeMap, "com.ibm.team.workitem.attribute.id", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.ITEM_TYPE, planElementAttributeMap, "com.ibm.team.workitem.attribute.workitemtype", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.DESCRIPTION, planElementAttributeMap, "com.ibm.team.workitem.attribute.description", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.CREATOR, planElementAttributeMap, "com.ibm.team.workitem.attribute.creator", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.CATEGORY, planElementAttributeMap, "com.ibm.team.workitem.attribute.category", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.TARGET, planElementAttributeMap, "com.ibm.team.workitem.attribute.target", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.TAGS, planElementAttributeMap, "com.ibm.team.workitem.attribute.tags", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.PRIORITY, planElementAttributeMap, "com.ibm.team.workitem.attribute.priority", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.SEVERITY, planElementAttributeMap, "com.ibm.team.workitem.attribute.severity", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.MINIMAL_ESTIMATE, planElementAttributeMap, "com.ibm.team.tempo.estimate.mininal", attributeMap, null); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.MAXIMAL_ESTIMATE, planElementAttributeMap, "com.ibm.team.tempo.estimate.maximal", attributeMap, null); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.ORIGINAL_ESTIMATE, planElementAttributeMap, "com.ibm.team.workitem.attribute.duration", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.CORRECTED_ESTIMATE, planElementAttributeMap, "com.ibm.team.workitem.attribute.correctedestimate", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.TIMESPENT, planElementAttributeMap, "com.ibm.team.workitem.attribute.timespent", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.DUE_DATE, planElementAttributeMap, "com.ibm.team.workitem.attribute.duedate", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.RESOLUTION_DATE, planElementAttributeMap, "com.ibm.team.workitem.attribute.resolutiondate", attributeMap); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.STATE, planElementAttributeMap, "com.ibm.team.workitem.attribute.state", attributeMap, StateAttribute); //$NON-NLS-1$
		this.__addWorkItemAttribute(PlanItem.DUE_DATE, planElementAttributeMap, "com.ibm.team.workitem.attribute.duedate", attributeMap); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.PRIMARY_TAG, planElementAttributeMap, "primaryTag", GetterKind.GET, SetterKind.SET); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.ESTIMATE, planElementAttributeMap, "estimate", GetterKind.GET, SetterKind.SET); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.DURATION, planElementAttributeMap, "duration", GetterKind.GET, SetterKind.SET); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.EFFORT, planElementAttributeMap, "effort", GetterKind.GET, SetterKind.SET); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.DRAFT_ITEM, planElementAttributeMap, "draftItem", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.AUXILIARY_ITEM, planElementAttributeMap, "auxiliaryPlanItem", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.PRIMARY_ITEM, planElementAttributeMap, "primaryPlanItem", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.MARKED_READ, planElementAttributeMap, "markedRead", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.NEW_ITEM, planElementAttributeMap, "newItem", GetterKind.IS, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.PARENT, planElementAttributeMap, "parent", GetterKind.NONE, SetterKind.NONE); //$NON-NLS-1$
		this.__addReflectiveAttribute(PlanItem.TIMELINE, planElementAttributeMap, "timeline", GetterKind.GET, SetterKind.NONE); //$NON-NLS-1$
		
		// TODO this is a bit of a hack for now to allow the WORKFLOW_ACTION to synchronize itself with the working copy
		var workflowActionAttribute= new WorkflowActionAttribute(PlanItem.WORKFLOW_ACTION.getId(), this.__getAttributeDescriptor(PlanItem.WORKFLOW_ACTION, planElementAttributeMap));
		this.__workItemAttributes["workflowAction"]= workflowActionAttribute; //$NON-NLS-1$
		this.__attributeRegistry.registerAttribute(workflowActionAttribute);

		dojo.forEach(planElementAttributes, function(descriptor) {
			var attributeIdentifier= new PlanningAttributeIdentifier(descriptor.id);
			if (descriptor.implementation == "com.ibm.team.apt.client.WorkItemAttribute") { //$NON-NLS-1$
				this.__addWorkItemAttribute(attributeIdentifier, planElementAttributeMap, descriptor.parameters["attribute"], attributeMap); //$NON-NLS-1$
			} else if (descriptor.implementation == "com.ibm.team.apt.client.RankingAttribute") { //$NON-NLS-1$
				var rankingAttribute= descriptor.parameters["attribute"]; //$NON-NLS-1$
				
				var sequenceAttributeId= rankingAttribute + "." + com.ibm.team.apt.client.RankingAttribute.SEQUENCE_ATTRIBUTE_ID_SUFFIX; //$NON-NLS-1$
				this.__addWorkItemAttribute(new PlanningAttributeIdentifier(sequenceAttributeId), planElementAttributeMap, sequenceAttributeId, attributeMap, SequenceAttribute); //$NON-NLS-1$

				var attributeCtor= descriptor.getConstructor();
				var rankingAttribute= new attributeCtor(descriptor);
				
				this.__attributeRegistry.registerAttribute(rankingAttribute);
				toInitialize.push(rankingAttribute);
			} else if (descriptor.implementation != "com.ibm.team.apt.client.BuiltInAttribute") { //$NON-NLS-1$
				var attributeCtor= descriptor.getConstructor();
				var customAttribute= new attributeCtor(descriptor);
				this.__attributeRegistry.registerAttribute(customAttribute);
				toInitialize.push(customAttribute);
			}
		}, this);
		
		dojo.forEach(toInitialize, function(attribute) {
			attribute.initialize(this);
			
			if (dojo.isFunction(attribute.getDependantAttributes)) {
				dojo.forEach(attribute.getDependantAttributes(), function(dependantAttribute) {
					var dependencies= this.__attributeDependencies[dependantAttribute.getId()];
					if (!dependencies) {
						dependencies= [];
						this.__attributeDependencies[dependantAttribute.getId()]= dependencies;
					}
					
					dependencies.push(attribute);
				}, this);
			}
		}, this);
	},
	
	__addReflectiveAttribute: function(planAttributeId, planElementAttributeMap, accessorName, getter, setter, valueSet) {
		var descriptor= this.__getAttributeDescriptor(planAttributeId, planElementAttributeMap);
		
		var attribute= new ReflectiveAttribute(descriptor, accessorName, getter, setter, valueSet);
		this.__attributeRegistry.registerAttribute(attribute);
	},
	
	__addWorkItemAttribute: function(planAttributeId, planElementAttributeMap, workItemAttributeId, attributeMap, ctor, typeHint) {
		this.__attributeRegistry.registerAttribute(this.__createWorkItemAttribute.apply(this, arguments));
	},
	
	__createWorkItemAttribute: function(planAttributeId, planElementAttributeMap, workItemAttributeId, attributeMap, ctor, typeHint) {
		var result= null;
		var descriptor= this.__getAttributeDescriptor(planAttributeId, planElementAttributeMap);

		if (!ctor)
			ctor= PlanItemWorkItemAttribute;
		var workItemAttributeDetails= attributeMap[workItemAttributeId];
		if (workItemAttributeDetails) {
			result= new ctor(descriptor, workItemAttributeDetails.attribute, workItemAttributeDetails.index);
			this.__workItemAttributes[workItemAttributeDetails.attribute.internalId]= result;
		} else {
			result= new UnresolvedWorkItemAttribute(descriptor, typeHint);
		}

		return result;
	},
	
	__getAttributeDescriptor: function(planAttributeId, planElementAttributeMap) {
		var result= planElementAttributeMap[planAttributeId.getId()];
		if (!result) {
			result= new com.ibm.team.apt.common.AttributeDescription.create(planAttributeId.getId(), "STRING", planAttributeId.getId()); //$NON-NLS-1$
			result.parameters['addCustomAttributes']= "true"; //$NON-NLS-1$ //$NON-NLS-2$
		}

		return result;
	},

	__sentinel: null // terminates this class definition
});

com.ibm.team.apt.client.PlanModel.RESOURCE_PLANNING= new PlanningAttributeIdentifier("com.ibm.team.apt.attribute.planmodel.resourcePlanning"); //$NON-NLS-1$
com.ibm.team.apt.client.PlanModel.REFERENCE_TIME= new PlanningAttributeIdentifier("com.ibm.team.apt.attribute.planmodel.referenceTime"); //$NON-NLS-1$

})();
