/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.attributes.StateAttribute"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.internal.attributes.PlanItemWorkItemAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.mixins.WorkflowInfo");//$NON-NLS-1$

(function() {
	
var PlanItemWorkItemAttribute		= com.ibm.team.apt.client.internal.attributes.PlanItemWorkItemAttribute;
var ReferencedItemStore				= com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore;
var WorkflowInfo					= com.ibm.team.apt.web.client.internal.mixins.WorkflowInfo;

dojo.declare("com.ibm.team.apt.client.internal.attributes.StateAttribute", PlanItemWorkItemAttribute, {  //$NON-NLS-1$
	
	constructor: function(descriptor, workItemAttribute, valueIndex) {
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	_convertToPlanItem: function(value, receiver) {
  		return receiver.getPlanModel().getItem(this.inherited(arguments), ReferencedItemStore.ITEM_TYPES.WORKFLOWSTATE);
	},

	_convertToWorkItem: function(value, receiver) {
		return this.inherited("_convertToWorkItem", arguments, [ value.itemId, receiver ]); //$NON-NLS-1$
	},
	
	__doSetValue: function(receiver, newValue, triggerWorkItemSave) {
		//A state can not be saved, ever. Only a workflow action can change the state!
		this.inherited("__doSetValue", arguments, [ receiver, newValue, false ]); //$NON-NLS-1$
	},

	_changed: function(receiver, oldValue, newValue, deltaBuilder) {
		this.inherited(arguments);

		var workflowInfo= receiver.getWorkflowInfo();
		var wasResolved= workflowInfo.getStateGroup(oldValue.itemId) == WorkflowInfo.DONE;
		var isResolved= workflowInfo.getStateGroup(newValue.itemId) == WorkflowInfo.DONE;

		if (wasResolved != isResolved) {
			deltaBuilder.changed(receiver, com.ibm.team.apt.client.PlanItem.RESOLVED, wasResolved, isResolved);
		}
	},
	
	__sentinel: null // terminates this class definition
});

})();
