/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.common.Category"); //$NON-NLS-1$

(function() {


dojo.declare("com.ibm.team.workitem.common.Category", null, { //$NON-NLS-1$

	__categoryId: null,

	constructor: function(categoryDTO) {
		this.itemId= categoryDTO.itemId;
		this.itemType= categoryDTO.itemType;
		this.label= categoryDTO.label;
		this.iconURL= categoryDTO.iconURL;
		this.archived= categoryDTO.archived;
		this.getParent= categoryDTO.getParent;
		this.__categoryId= categoryDTO.categoryId;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	itemId: null,
	itemType: null,
	label: null,
	iconURL: null,
	archived: null,

	getParent: function() {
		return null;
	},
	
	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.itemId == other.itemId;
	},

	compareTo: function(other) {
		if (this.__categoryId < other.__categoryId)
			return -1;

		if (this.__categoryId > other.__categoryId)
			return 1;

		return 0;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});


})();
